||LABELS

| The Big Default
******** **** * | noop; LDOP; ADR+

0x01 = call(rtnlo, rtnhi, subrlo, subrhi)
0 *  | MAR <- 0xFF; CC=P0
1 *  | A   <- SRAM
2 *  | MAR <- A
3 *  | SRAM <- uROM; ADR+
4 *  | A   <- A-1
5 *  | MAR <- A
6 *  | SRAM <- uROM; ADR+
7 *  | MAR <- 0xFF
8 *  | SRAM <- A-1
9 *  | A   <- uROM; ADR+
A *  | ADR <- uROM;
B *  | ADR <- A; 
C *  | NOOP; LDOP; ADR+

0x02 = rtn()
| NB: This opcode (2) is built into ctlrom code for urom(), below.
| DO NOT CHANGE IT without modifying urom code.
0 *  | MAR <- 0xFF
1 *  | A   <- SRAM
2 *  | A   <- A+1
3 *  | MAR <- A
4 *  | ADR <- SRAM
5 *  | A   <- A+1
6 *  | MAR <- A 
7 *  | ADR <- SRAM
8 *  | MAR <- 0xFF
9 *  | SRAM <- A; LDOP; ADR+

0x03 = push(x)
0 *  | MAR <- 0xFF
1 *  | A   <- SRAM
2 *  | SRAM <- A-1
3 *  | MAR <- uROM; ADR+
4 *  | B   <- SRAM
5 *  | MAR <- A
6 *  | SRAM <- B; LDOP; ADR+

0x04 = pop(x)
0 *  | MAR <- 0xFF
1 *  | A   <- SRAM
2 *  | A   <- A+1
3 *  | SRAM <- A
4 *  | MAR <- A
5 *  | A   <- SRAM
6 *  | MAR <- uROM; ADR+
7 *  | SRAM <- A; LDOP; ADR+

0x05 = move(x, y)
| [move value]    y <- <x>
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | SRAM <- A; LDOP; ADR+

0x06 = cmove(cx, y)  [move constant]  y <- cx
0 *  | A   <- uROM; ADR+
1 *  | MAR <- uROM; ADR+
2 *  | SRAM <- A; LDOP; ADR+

0x07 = swt(x)        x <- switches
0 *  | MAR <- uROM; ADR+
1 *  | SRAM <- SWT; LDOP; ADR+

0x08 = pdisp(x, p00, p01, p10, p11)
| Displays <x> in the lights.  Dispatches to (2-byte) location
| pyz where y is state of P0, z is state of P1.  Does not put data 
| other than <x> in lights, hence suitable for tight "prompt" loop.
| XXX pdisp refreshes one row of DRAM
0 *  | MAR <- uROM; ADR+
1 *  | B <- SRAM; CC; CC=P0
| If P0=1, uROM adr is incremented 4 times as well to point to p10 in uROM.
2 0  | A <- 0xFF
2 1  | A <- 0xFF; ADR+
3 0  | MAR <- A-1
3 1  | MAR <- A-1; ADR+
4 0  | A <- SRAM
4 1  | A <- SRAM; ADR+
5 1  | DRAM <- A; ADR+; CC=P1
5 0  | DRAM <- A; CC=P1
6 0  | SRAM <- A+1
6 1  | SRAM <- A+1; ADR+
7 0  | noop
7 1  | noop; ADR+
8 *  | A   <- uROM; ADR+
9 *  | ADR <- uROM
A *  | ADR <- A; 
B *  | NOOP; LDOP; ADR+

0x09 = pwrup()
0 *  | noop; ADR+;
**** *  | NOOP; LDOP; ADR+

0x0A = add(x, y, z)
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B   <- SRAM
4 *  | MAR <- uROM; ADR+
5 *  | SRAM <- A+B; CC; LDOP; ADR+

0x0B = cadd(cx, y, z)
0 *  | A   <- uROM; ADR+
1 *  | MAR <- uROM; ADR+
2 *  | B   <- SRAM
3 *  | MAR <- uROM; ADR+
4 *  | SRAM <- A+B; CC; LDOP; ADR+

0x0C = jmp(adrlo, adrhi)
0 *  | A   <- uROM; ADR+
1 *  | ADR <- uROM
2 *  | ADR <- A; 
3 *  | NOOP; LDOP; ADR+

0x0D = imove(x, y)    [move indir value]    y <- <<x>>
0 *  | MAR <- uROM; ADR+
1 *  | MAR <- SRAM
2 *  | A   <- SRAM
3 *  | MAR <- uROM; ADR+
4 *  | SRAM <- A; LDOP; ADR+

0x0E = movei(x, y)    [move value indir]    <y> <- <x>
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | MAR <- SRAM
4 *  | SRAM <- A; LDOP; ADR+

0x0F = l(adrlo, adrhi, where) -- DRAM load
0 *  | MAR <- uROM; ADR+
1 *  | A  <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | DRAM <- A # RAS
4 *  | DRAM <- SRAM # CAS
5 *  | MAR <- uROM; ADR+
6 *  | SRAM <- DRAM; LDOP; ADR+

0x10 = s(value, adrlo, adrhi) -- DRAM store
0 *  | MAR <- uROM; ADR+
1 *  | B  <- SRAM 
2 *  | MAR <- uROM; ADR+
3 *  | A <- SRAM
4 *  | MAR <- uROM; ADR+
5 *  | DRAM <- A 		
6 *  | DRAM <- SRAM 	
7 *  | DRAM <- B; LDOP; ADR+

0x11 = refr() - refresh 6 DRAM rows.
| This should NEVER be called!
0 *  | A <- 0xFF
1 *  | MAR <- A-1 	
2 *  | A   <- SRAM
3 *  | DRAM <- A
4 *  | A <- A+1
5 *  | DRAM <- A
6 *  | A <- A+1
7 *  | DRAM <- A
8 *  | A <- A+1
9 *  | DRAM <- A
A *  | A <- A+1
B *  | DRAM <- A
C *  | A <- A+1
D *  | DRAM <- A
E *  | SRAM <- A+1; LDOP; ADR+

| Conditional jumps CLOBBER CCs!

0x12 = jmi(adrlo, adrhi) -- jump if N set.
0 *  | A <- uROM; ADR+; CC=N
1 1  | ADR <- uROM
2 1  | ADR <- A; 
3 1  | NOOP; LDOP; ADR+

1 0  | A <- uROM; ADR+
2 0  | NOOP; LDOP; ADR+

0x13 = jextra(adrlo, adrhi) -- jump if extra (i.e., undefined) flag set.
| We have wired the undefined flag to the SP!C
0 *  | A <- uROM; ADR+; CC; CC=SP!C
1 1  | ADR <- uROM
2 1  | ADR <- A; 
3 1  | NOOP; LDOP; ADR+
1 0  | A <- uROM; ADR+
2 0  | NOOP; LDOP; ADR+

0x14 = jready(adrlo, adrhi) -- jump if I/O flag set. refresh one row.
0 *  | A <- 0xFF;
1 *  | MAR <- A-1
2 *  | A <- SRAM
3 *  | DRAM <- A
4 *  | SRAM <- A+1

5 *  | A <- uROM; ADR+; CC; CC=I/O
6 1  | ADR <- uROM
7 1  | ADR <- A; 
8 1  | NOOP; LDOP; ADR+
6 0  | A <- uROM; ADR+
7 0  | NOOP; LDOP; ADR+

0x15 = jp1(adrlo, adrhi) -- jump if P1 pressed.
0 *  | A <- uROM; ADR+; CC; CC=P1
1 1  | ADR <- uROM
2 1  | ADR <- A; 
3 1  | NOOP; LDOP; ADR+
1 0  | A <- uROM; ADR+
2 0  | NOOP; LDOP; ADR+

0x16 = jodd(adrlo, adrhi) -- jump if low ALU bit set.
0 *  | A <- uROM; ADR+; CC=D0
1 1  | ADR <- uROM
2 1  | ADR <- A; 
3 1  | NOOP; LDOP; ADR+
1 0  | A <- uROM; ADR+
2 0  | NOOP; LDOP; ADR+

0x17 = jnc(adrlo, adrhi) -- jump if Carry bit not set
0 *  | A <- uROM; ADR+; CC=!C
1 1  | ADR <- uROM
2 1  | ADR <- A; 
3 1  | NOOP; LDOP; ADR+
1 0  | A <- uROM; ADR+
2 0  | NOOP; LDOP; ADR+

0x18 = jp0(adrlo, adrhi) -- jump if P0 pressed.
0 * | A <- uROM; ADR+; CC; CC=P0
1 1 | ADR <- uROM
2 1 | ADR <- A
3 1 | NOOP; LDOP; ADR+
1 0 | A <- uROM; ADR+
2 0 | NOOP; LDOP; ADR+

0x19 = je(adrlo, adrhi) -- jump if Equal to 11111111	(0xFF)
0 *  | A <- uROM; ADR+; CC=E
1 1  | ADR <- uROM
2 1  | ADR <- A; 
3 1  | NOOP; LDOP; ADR+
1 0  | A <- uROM; ADR+
2 0  | NOOP; LDOP; ADR+

|         ************
| OPCODE  * 00011010 * is not currently used.
|         ************    ---

0x1C = sub(x, y, z) -- z <- x - y
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B   <- SRAM
4 *  | MAR <- uROM; ADR+
5 *  | SRAM <- A-B; CC; LDOP; ADR+

0x1D = cmp(x, y) --	 x-y-1; Latch CCs
| This operation produces no result other than in the condition codes.
| After the cmp(x,y) the significance of the condition codes is:
|	 E:	1 iff <x> = <y>
|	-C:	0 iff <x> > <y> (unsigned) ... i.e. is asserted active low.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B   <- SRAM
4 *  | A <- A-B-1; CC; LDOP; ADR+

0x1E = jpl(adrlo, adrhi) -- jump if N not set.
0 *  | A <- uROM; ADR+; CC=N

1 0  | ADR <- uROM
2 0  | ADR <- A; 
3 0  | NOOP; LDOP; ADR+

1 1  | A <- uROM; ADR+
2 1  | NOOP; LDOP; ADR+

0x1F = jnextra(adrlo, adrhi) -- jump if extra (i.e., undefined) flag
| not set.
| We have wired the undefined flag to SP!C
0 *  | A <- uROM; ADR+; CC; CC=SP!C
1 0  | ADR <- uROM
2 0  | ADR <- A; 
3 0  | NOOP; LDOP; ADR+
1 1  | A <- uROM; ADR+
2 1  | NOOP; LDOP; ADR+

0x20 = jnready(adrlo, adrhi) -- jump if I/O not flag set.
0 *  | A <- 0xFF;
1 *  | MAR <- A-1
2 *  | A <- SRAM
3 *  | DRAM <- A
4 *  | SRAM <- A+1

5 *  | A <- uROM; ADR+; CC; CC=I/O
6 0  | ADR <- uROM
7 0  | ADR <- A; 
8 0  | NOOP; LDOP; ADR+
6 1  | A <- uROM; ADR+
7 1  | NOOP; LDOP; ADR+

0x21 = jnp1(adrlo, adrhi) -- jump if P1 not pressed.
0 *  | A <- uROM; ADR+; CC; CC=P1
1 0  | ADR <- uROM
2 0  | ADR <- A; 
3 0  | NOOP; LDOP; ADR+
1 1  | A <- uROM; ADR+
2 1  | NOOP; LDOP; ADR+

0x22 = jeven(adrlo, adrhi) -- jump if low ALU bit not set.
0 *  | A <- uROM; ADR+; CC=D0
1 0  | ADR <- uROM
2 0  | ADR <- A; 
3 0  | NOOP; LDOP; ADR+
1 1  | A <- uROM; ADR+
2 1  | NOOP; LDOP; ADR+

0x23 = jc(adrlo, adrhi) -- jump if Carry bit set
0 *  | A <- uROM; ADR+; CC=!C
1 0  | ADR <- uROM
2 0  | ADR <- A; 
3 0  | NOOP; LDOP; ADR+
1 1  | A <- uROM; ADR+
2 1  | NOOP; LDOP; ADR+

0x24 = jnp0(adrlo, adrhi) -- jump if P0 not pressed.
0 *  | A <- uROM; ADR+; CC; CC=P0
1 0  | ADR <- uROM
2 0  | ADR <- A; 
3 0  | NOOP; LDOP; ADR+
1 1  | A <- uROM; ADR+
2 1  | NOOP; LDOP; ADR+

0x25 = jne(adrlo, adrhi) -- jump if not Equal to 11111111 (0xFF)
0 *  | A <- uROM; ADR+; CC=E
1 0  | ADR <- uROM
2 0  | ADR <- A; 
3 0  | NOOP; LDOP; ADR+
1 1  | A <- uROM; ADR+
2 1  | NOOP; LDOP; ADR+

0x26 = urom(adrlo, adrhi, x)
| read ucode uROM[SRAM[adrlo], SRAM[adrhi]] into SRAM[x]; then forces a rtn().
| NB: This code MUST change iff the opcode for RTN changes!
| Note also that this function serves no purpose any more..
| adrlo
0 *  | MAR <- uROM; ADR+	
1 *  | A   <- SRAM   		
2 *  | MAR <- uROM; ADR+	
3 *  | B   <- SRAM;		
4 *  | MAR <- uROM; ADR+;	
5 *  | ADR <- B; 		
6 *  | ADR <- A; 	 	
7 *  | SRAM <- uROM; 		
8 *  | A   <- 0
9 *  | A   <- A+1 		
A *  | A   <- A+1; LDOP; ADR+

0x27 = and(x, y, z)
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B   <- SRAM
4 *  | MAR <- uROM; ADR+
5 *  | SRAM <- A&B; CC; LDOP; ADR+

0x28 = or(x, y, z)
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B   <- SRAM
4 *  | MAR <- uROM; ADR+
5 *  | SRAM <- A|B; CC; LDOP; ADR+

0x29 = xor(x, y, z)
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B   <- SRAM
4 *  | MAR <- uROM; ADR+
5 *  | SRAM <- A xor B; CC; LDOP; ADR+

0x2A = not(x, y)
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | SRAM <- not A; CC; LDOP; ADR+

0x2B = neg(x, y)
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | A   <- not A
4 *  | SRAM <- A+1; CC; LDOP; ADR+

| Following are a few 2-byte operators

0x2C = add2(xlo, ylo, zlo, xhi, yhi, zhi) -- 16-bit add.
0 *  | MAR <- uROM; ADR+
1 *  | A <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B <- SRAM
4 *  | MAR <- uROM; ADR+
5 *  | SRAM <- A+B; CC
6 *  | MAR <- uROM; ADR+
7 *  | A <- SRAM
8 *  | MAR <- uROM; ADR+
9 *  | B <- SRAM
A *  | MAR <- uROM; ADR+; CC=!C
B 1  | SRAM <- A+B; CC; LDOP; ADR+
B 0  | SRAM <- A+B+1; CC; LDOP; ADR+

0x2D = cadd2(cxlo, ylo, zlo, cxhi, yhi, zhi) -- 16-bit add.
0 *  | A <- uROM; ADR+
1 *  | MAR <- uROM; ADR+
2 *  | B <- SRAM
3 *  | MAR <- uROM; ADR+
4 *  | SRAM <- A+B; CC
5 *  | A <- uROM; ADR+;
6 *  | MAR <- uROM; ADR+
7 *  | B <- SRAM
8 *  | MAR <- uROM; ADR+; CC=!C
9 1  | SRAM <- A+B; CC; LDOP; ADR+
9 0  | SRAM <- A+B+1; CC; LDOP; ADR+

0x2E = sub2(xlo, ylo, zlo, xhi, yhi, zhi) -- 16-bit subtract.
0 *  | MAR <- uROM; ADR+
1 *  | A <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B <- SRAM
4 *  | MAR <- uROM; ADR+
5 *  | SRAM <- A-B; CC
6 *  | MAR <- uROM; ADR+
7 *  | A <- SRAM
8 *  | MAR <- uROM; ADR+
9 *  | B <- SRAM
A *  | MAR <- uROM; ADR+; CC=!C
B 0  | SRAM <- A-B; CC; LDOP; ADR+
B 1  | SRAM <- A-B-1; CC; LDOP; ADR+

0x2F = cmp2(xlo, ylo, xhi, yhi) -- 16-bit compare.
| This operation produces no result other than in the condition codes.
| After the cmp(x,y) the significance of the condition codes is:
|	 E:	1 iff <x> = <y>
|	-C:	0 iff <x> > <y> (unsigned) ... i.e. is asserted active low
0 *  | MAR <- uROM; ADR+
1 *  | A <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B <- SRAM

4 *  | A <- A-B-1; CC
5 *  | MAR <- uROM; ADR+
6 *  | A <- SRAM
7 *  | MAR <- uROM; ADR+
8 *  | B <- SRAM; CC=!C
9 0  | A <- A-B; CC; LDOP; ADR+
9 1  | A <- A-B-1; CC; LDOP; ADR+

0x30 = count(x) -- counts down <x>, setting flags.
| Doesn't disturb <B>, hence lights.
0 * | MAR <- uROM; ADR+
1 * | A   <- SRAM
2 * | SRAM <- A-1; CC; LDOP; ADR+

0x31 = cond(x) -- copies condition register into SRAM<x>.
|			           .----------------------------------------.
|	 CC Format:   ctl ROM <-   |  N | -C |  E | D0 | P0 | P1 | I/O | ?? |
|			           `----------------------------------------'
|				      <---   Direction of shift   <---

0 * | MAR <- uROM; ADR+; CC=N
1 0 | A <- A+A; CC=!C
1 1 | A <- A+A+1; CC=!C
2 0 | A <- A+A; CC=E
2 1 | A <- A+A+1; CC=E
3 0 | A <- A+A; CC=D0
3 1 | A <- A+A+1; CC=D0
4 0 | A <- A+A; CC=P0
4 1 | A <- A+A+1; CC=P0
5 0 | A <- A+A; CC=P1
5 1 | A <- A+A+1; CC=P1
6 0 | A <- A+A; CC=I/O
6 1 | A <- A+A+1; CC=I/O
7 0 | A <- A+A; CC=SP!C
7 1 | A <- A+A+1; CC=SP!C
8 0 | A <- A+A;
8 1 | A <- A+A+1;
9 * | SRAM <- A; LDOP; ADR+

0x32 = negcy(x, y) - negate with carry input.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | A   <- not A; CC=!C
4 1  | SRAM <- A; CC; LDOP; ADR+
4 0  | SRAM <- A+1; CC; LDOP; ADR+

0x33 = subcy(x, y, z) --  z <- x - y with carry input.
0 *  | MAR <- uROM; ADR+; 
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B   <- SRAM
4 *  | MAR <- uROM; ADR+; CC=!C
5 0  | SRAM <- A-B; CC; LDOP; ADR+
5 1  | SRAM <- A-B-1; CC; LDOP; ADR+

0x34 = readio(r,y) -- y <- [r] where [N] means "contents of I/O internal reg N"
0 *  | I/OADR <- uROM; ADR+
1 *  | MAR  <- uROM; ADR+
2 *  | SRAM <- I/O; LDOP; ADR+

0x35 = ireadio(x,y) -- y <- [<x>] where [N] means "contents of I/O internal reg N"
0 *  | MAR  <- uROM; ADR+
1 *  | I/OADR <- SRAM
2 *  | MAR  <- uROM; ADR+
3 *  | SRAM <- I/O; LDOP; ADR+

0x36 = writeio(x,r) --  io r <- <x>  (i.e., <x> into I/O reg referenced by y)
| >>>>> NOTE  <<<<<  ARGUMENTS ARE REVERSED BY MACRO (see macros.uasm)
0 *  | I/OADR <- uROM;ADR+	
1 *  | MAR <- uROM; ADR+	
2 *  | I/O <- SRAM; LDOP; ADR+

0x37 = writeioi(x,y) --  io <y> <- <x> (i.e., <x> into I/O reg referenced by y)
| >>>>> NOTE  <<<<<  ARGUMENTS ARE REVERSED BY MACRO (see macros.uasm)
0 *  | MAR <- uROM; ADR+	
1 *  | I/OADR <- SRAM
2 *  | MAR <- uROM; ADR+	
3 *  | I/O <- SRAM; LDOP; ADR+


|>>>>>>>>>>>><<<<<<<<<<
|>>> UNUSED OPCODES <<<  Opcodes  0011100 - 01111111  are NOT currently used.
|>>>>>>>>>>>><<<<<<<<<<                                   ===

0x80 = dispatch(x, tabhi, tablo)
| Takes (tabhi, tablo) as the address in uROM of a dispatch table,
|   whose consecutive entries are each 2-byte uROM addresses stored
|   (low, high).  Uses contents of SRAM register x as an index into
|   this table, and jumps to the indexed entry.  Note that the
|   uROM address of the entry is adr+x+x, since entries are 2 bytes
|   each; phases 0 thru 1011 compute this value and load it into
|   ADR.  Note use of SRAM location beyond stack as a temporary.
|
| NB:  nonstandard order of (tabhi, tablo) arguments
0 *  | MAR <- uROM; ADR+	 # | (= x);
1 *  | A   <- SRAM 		 # | (= <x>)
2 *  | MAR <- 0xFF
3 *  | MAR <- SRAM 		 # | (= <0xFF>)
4 *  | B <- A+A; CC		 # | (=<x>+<x>)
5 *  | A <- uROM; ADR+; CC=!C	 # | (tabhi)
6 1  | SRAM <- A		 # | (tabhi+C1)
6 0  | SRAM <- A+1		 # | (tabhi+C1)
7 *  | A   <- uROM; ADR+	 # | (tablo)
8 *  | B <- A+B; CC; CC=!C	 # | (x+x+tablo)
9 *  | A <- SRAM;		 # | (tabhi+C1)
A 1  | ADR <- A			 # | (tabhi+C1+C2)
A 0  | ADR <- A+1		 # | (tabhi+C1+C2)
B *  | ADR <- B          	 # | (x+x+tablo)
C *  | A   <- uROM; ADR+
D *  | ADR <- uROM
E *  | ADR <- A; 
F *  | NOOP; LDOP; ADR+

0x81 = addcy(x, y, z)
| Like add(x, y, z), but adds in the incoming carry bit.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+
3 *  | B   <- SRAM
4 *  | MAR <- uROM; ADR+; CC=!C
5 1  | SRAM <- A+B; CC; LDOP; ADR+
5 0  | SRAM <- A+B+1; CC; LDOP; ADR+

0x82 = caddcy(cx, y, z)
| Like cadd, but adds in the incoming carry bit.
0 *  | A   <- uROM; ADR+
1 *  | MAR <- uROM; ADR+
2 *  | B   <- SRAM
3 *  | MAR <- uROM; ADR+; CC=!C
4 1  | SRAM <- A+B; CC; LDOP; ADR+
4 0  | SRAM <- A+B+1; CC; LDOP; ADR+

0x83 = cand(cx, y, z)
0 *  | A   <- uROM; ADR+
1 *  | MAR <- uROM; ADR+
2 *  | B   <- SRAM
3 *  | MAR <- uROM; ADR+
4 *  | SRAM <- A&B; CC; LDOP; ADR+

|>>>>>>>>>>>><<<<<<<<<<
|>>> UNUSED OPCODE  <<<  Opcode  10001000  is NOT currently used.
|>>>>>>>>>>>><<<<<<<<<<                       ===

0x89 = rotl1(x, y) -- left rotate x 1 position.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+; CC; CC=N
3 0  | SRAM <- A+A; CC; CC=N; LDOP; ADR+
3 1  | SRAM <- A+A+1; CC; CC=N; LDOP; ADR+

0x8A = rotl2(x, y) -- left rotate x 2 positions.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+; CC; CC=N

3 0  | A    <- A+A; CC; CC=N
4 0  | SRAM <- A+A; CC; CC=N; LDOP; ADR+

3 1  | A    <- A+A+1; CC; CC=N
4 1  | SRAM <- A+A+1; CC; CC=N; LDOP; ADR+

0x8B = rotl3(x, y) -- left rotate x 3 positions.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+; CC; CC=N

3 0  | A    <- A+A; CC; CC=N
4 0  | A    <- A+A; CC; CC=N
5 0  | SRAM <- A+A; CC; CC=N; LDOP; ADR+

3 1  | A    <- A+A+1; CC; CC=N
4 1  | A    <- A+A+1; CC; CC=N
5 1  | SRAM <- A+A+1; CC; CC=N; LDOP; ADR+

0x8C = rotl4(x, y) -- left rotate x 4 positions.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+; CC; CC=N

3 0  | A    <- A+A; CC; CC=N
4 0  | A    <- A+A; CC; CC=N
5 0  | A    <- A+A; CC; CC=N
6 0  | SRAM <- A+A; CC; CC=N; LDOP; ADR+

3 1  | A    <- A+A+1; CC; CC=N
4 1  | A    <- A+A+1; CC; CC=N
5 1  | A    <- A+A+1; CC; CC=N
6 1  | SRAM <- A+A+1; CC; CC=N; LDOP; ADR+

0x8D = rotl5(x, y) -- left rotate x 5 positions.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+; CC; CC=N

3 0  | A    <- A+A; CC; CC=N
4 0  | A    <- A+A; CC; CC=N
6 0  | A    <- A+A; CC; CC=N
5 0  | A    <- A+A; CC; CC=N
7 0  | SRAM <- A+A; CC; CC=N; LDOP; ADR+

3 1  | A    <- A+A+1; CC; CC=N
4 1  | A    <- A+A+1; CC; CC=N
5 1  | A    <- A+A+1; CC; CC=N
6 1  | A    <- A+A+1; CC; CC=N
7 1  | SRAM <- A+A+1; CC; CC=N; LDOP; ADR+

0x8E = rotl6(x, y) -- left rotate x 6 positions.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+; CC; CC=N

3 0  | A    <- A+A; CC; CC=N
4 0  | A    <- A+A; CC; CC=N
5 0  | A    <- A+A; CC; CC=N
6 0  | A    <- A+A; CC; CC=N
7 0  | A    <- A+A; CC; CC=N
8 0  | SRAM <- A+A; CC; CC=N; LDOP; ADR+

3 1  | A    <- A+A+1; CC; CC=N
4 1  | A    <- A+A+1; CC; CC=N
5 1  | A    <- A+A+1; CC; CC=N
6 1  | A    <- A+A+1; CC; CC=N
7 1  | A    <- A+A+1; CC; CC=N
8 1  | SRAM <- A+A+1; CC; CC=N; LDOP; ADR+

0x8F = rotl7(x, y) -- left rotate x 7 positions.
0 *  | MAR <- uROM; ADR+
1 *  | A   <- SRAM
2 *  | MAR <- uROM; ADR+; CC; CC=N
| Following states shift in sign bit (remember, Cin is asserted low)
3 0  | A    <- A+A; CC; CC=N
4 0  | A    <- A+A; CC; CC=N
5 0  | A    <- A+A; CC; CC=N
6 0  | A    <- A+A; CC; CC=N
7 0  | A    <- A+A; CC; CC=N
8 0  | A    <- A+A; CC; CC=N
9 0  | SRAM <- A+A; CC; CC=N; LDOP; ADR+

3 1  | A    <- A+A+1; CC; CC=N
4 1  | A    <- A+A+1; CC; CC=N
5 1  | A    <- A+A+1; CC; CC=N
6 1  | A    <- A+A+1; CC; CC=N
7 1  | A    <- A+A+1; CC; CC=N
8 1  | A    <- A+A+1; CC; CC=N
9 1  | SRAM <- A+A+1; CC; CC=N; LDOP; ADR+

|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
|| Nanocode stack functions
||
|| Convention: microinstructions that deal with the DRAM stack
|| directly are prefaced with "ns" -- the "s" for "stack" and the "n"
|| for "nano", so that name clashes don't occur.
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

0x90 = nspop1(x)
| pops next byte into SRAM x, leaving it in GR1.
| 5 cycles
0 * | MAR <- uROM ; ADR+
1 * | SPa,DRAM <- SPa-1; CC=SP!C
2 1 | SPb,DRAM <- SPb-1
2 0 | DRAM <- SPb
3 * | SRAM <- DRAM; LDGR1; LDOP; ADR+

0x91 = nspop2(y, x)
| Pops two bytes from TOS into SRAM<y>, SRAM<x>.  Leaves the high
| byte in GR1.
0 * | MAR <- uROM; ADR+
1 * | SPa,DRAM <- SPa-1; CC=SP!C
2 1 | SPb,DRAM <- SPb-1
2 0 | DRAM <- SPb
3 * | SRAM <- DRAM; LDGR1
4 * | MAR <- uROM; ADR+
5 * | SPa,DRAM <- SPa-1; CC=SP!C
6 1 | SPb,DRAM <- SPb-1
6 0 | DRAM <- SPb
7 * | SRAM <- DRAM; LDOP; ADR+

0x92 = nspush1(x)
| Pushes one byte from SRAM<x> to TOS.
0 * | MAR <- uROM; ADR+
1 * | DRAM <- SPa
2 * | DRAM <- SPb
3 * | DRAM <- SRAM
4 * | SPa <- SPa+1; CC=SP!C
5 0 | SPb <- SPb+1; LDOP; ADR+
5 1 | NOOP; LDOP; ADR+

0x93 = nspush2(x, y)
| Pushes the bytes from SRAM<x>,SRAM<y> to TOS.
0 * | MAR <- uROM; ADR+
1 * | DRAM <- SPa
2 * | DRAM <- SPb
3 * | DRAM <- SRAM
4 * | MAR <- uROM; ADR+
5 * | SPa <- SPa+1; CC=SP!C
6 0 | SPb <- SPb+1
6 1 | NOOP
7 * | DRAM <- SPa
8 * | DRAM <- SPb
9 * | DRAM <- SRAM
A * | SPa <- SPa+1; CC=SP!C
B 0 | SPb <- SPb+1; LDOP; ADR+
B 1 | NOOP; LDOP; ADR+

0x94 = spstore(x, y)
| Stores the (2-byte) stack pointer into SRAM<x>,SRAM<y> low byte first.
0 * | MAR <- uROM; ADR+
1 * | SRAM <- SPa
2 * | MAR <- uROM; ADR+
3 * | SRAM <- SPb; LDOP; ADR+

0x95 = spload(x, y)
| Loads the stack pointer: (SPa, SPb) <- (SRAM<x>, SRAM<y>)
0 * | MAR <- uROM; ADR+
1 * | SPa <- SRAM
2 * | MAR <- uROM; ADR+
3 * | SPb <- SRAM; LDOP; ADR+

0x96 = signex1(x)
| "Sign extends" into x, assuming the value to be sign-extended is
| in GR1.  Intended to be called after a pop.
0 * | A <- GR1;
1 * | MAR <- uROM; ADR+; CC; CC=N
2 0 | SRAM <- 0x00; LDOP; ADR+
2 1 | SRAM <- 0xFF; LDOP; ADR+

0x97 = signex2(x, y)
| "Sign extends" into x and y, same assumptions.
0 * | A <- GR1
1 * | MAR <- uROM; ADR+; CC; CC=N
2 0 | SRAM <- 0x00
2 1 | SRAM <- 0xFF
3 * | MAR <- uROM; ADR+
4 0 | SRAM <- 0x00; LDOP; ADR+
4 1 | SRAM <- 0xFF; LDOP; ADR+

0x98 = signex3(x, y, z)
| "Sign extends" into x, y, and z, same assumptions.
0 * | A <- GR1
1 * | MAR <- uROM; ADR+; CC; CC=N
2 0 | SRAM <- 0x00
2 1 | SRAM <- 0xFF
3 * | MAR <- uROM; ADR+
4 0 | SRAM <- 0x00
4 1 | SRAM <- 0xFF
5 * | MAR <- uROM; ADR+
6 0 | SRAM <- 0x00; LDOP; ADR+
6 1 | SRAM <- 0xFF; LDOP; ADR+

0x99 = spadd2(x, y)
| Adds the two-byte value at SRAM<x>,SRAM<y> to the stack pointer
0 * | MAR <- uROM; ADR+
1 * | A <- SRAM
2 * | B <- SPa
3 * | SPa <- A+B; CC
4 * | MAR <- uROM; ADR+
5 * | A <- SRAM
6 * | B <- SPb; CC=!C
7 0 | SPb <- A+B+1; CC; LDOP; ADR+
7 1 | SPb <- A+B; CC; LDOP; ADR+

0x9A = sppush
| Pushes the value of the stack pointer at the time the instruction is
| called onto the stack.
0 * | DRAM <- SPa; LDGR1
1 * | DRAM <- SPb; LDGR2
2 * | DRAM <- GR1
3 * | SPa <- SPa+1; CC=SP!C
4 0 | SPb <- SPb+1
4 1 | NOOP
5 * | DRAM <- SPa
6 * | DRAM <- SPb
7 * | DRAM <- GR2
8 * | SPa <- SPa+1; CC=SP!C
9 0 | SPb <- SPb+1; LDOP; ADR+
9 1 | NOOP; LDOP; ADR+

0x9B = sppop
| Pops two bytes off the stack and loads them into the stack pointer.
0 * | SPa,DRAM <- SPa-1; CC=SP!C
1 1 | SPb,DRAM <- SPb-1
1 0 | DRAM <- SPb
2 * | noop <- DRAM; LDGR1
3 * | SPa,DRAM <- SPa-1; CC=SP!C
4 1 | SPb,DRAM <- SPb-1
4 0 | DRAM <- SPb
5 * | noop <- DRAM; LDGR2
6 * | SPa <- GR2
7 * | SPb <- GR1; LDOP; ADR+

0x9C = nspop4(z, y, x, w)
| Pops two bytes from TOS into SRAM<z,y,x,w>.  Leaves the high
| byte in GR1.
0 * | MAR <- uROM; ADR+
1 * | SPa,DRAM <- SPa-1; CC=SP!C
2 1 | SPb,DRAM <- SPb-1
2 0 | DRAM <- SPb
3 * | SRAM <- DRAM; LDGR1
4 * | MAR <- uROM; ADR+
5 * | SPa,DRAM <- SPa-1; CC=SP!C
6 1 | SPb,DRAM <- SPb-1
6 0 | DRAM <- SPb
7 * | SRAM <- DRAM;
8 * | MAR <- uROM; ADR+
9 * | SPa,DRAM <- SPa-1; CC=SP!C
A 1 | SPb,DRAM <- SPb-1
A 0 | DRAM <- SPb
B * | SRAM <- DRAM
C * | MAR <- uROM; ADR+
D * | SPa,DRAM <- SPa-1; CC=SP!C
E 1 | SPb,DRAM <- SPb-1
E 0 | DRAM <- SPb
F * | SRAM <- DRAM; LDOP; ADR+

0x9D = signex4(w, x, y, z)
| "Sign extends" into w, x, y, and z, same assumptions.
0 * | A <- GR1
1 * | MAR <- uROM; ADR+; CC; CC=N
2 0 | SRAM <- 0x00
2 1 | SRAM <- 0xFF
3 * | MAR <- uROM; ADR+
4 0 | SRAM <- 0x00
4 1 | SRAM <- 0xFF
5 * | MAR <- uROM; ADR+
6 0 | SRAM <- 0x00
6 1 | SRAM <- 0xFF
7 * | MAR <- uROM; ADR+
8 0 | SRAM <- 0x00; LDOP; ADR+
8 1 | SRAM <- 0xFF; LDOP; ADR+

0x9F = nspeek1(x)
| Peeks at the top stack value and puts it in SRAM<x>.
0 * | MAR <- uROM; ADR+
1 * | DRAM <- SPa-1; CC=SP!C
2 1 | DRAM <- SPb-1
2 0 | DRAM <- SPb
3 * | SRAM <- DRAM; LDOP; ADR+

|>>>>>>>>>>>><<<<<<<<<<
|>>> UNUSED OPCODES <<<  Opcodes  10001111 - 11111110  are NOT currently used.
|>>>>>>>>>>>><<<<<<<<<<                                    ===

0xAA = gdatum(x,y,z)   <z> <- <<x:y>>; x:y <- <x:y> + 1; z <- <z> + 1;
| gdatum(x,y,z)   <z> <- <<x:y>>; x:y <- <x:y> + 1; z <- <z> + 1;
0 * | MAR <- uROM; ADR+
1 * | A <- SRAM
2 * | SRAM <- A+1; CC
3 * | MAR <- uROM; ADR+;
4 * | DRAM <- A
5 * | DRAM <- SRAM
6 * | A <- SRAM; CC=!C
7 0 | SRAM <- A+1;
7 1 | NOOP
8 * | A <- uROM; ADR+
9 * | MAR <- A
A * | MAR <- SRAM
B * | SRAM <- DRAM
C * | MAR <- A
D * | A <- SRAM
E * | SRAM <- A+1; CC; LDOP; ADR+

0xAB = pdatum(R2, R0, R1)
| <R0:R1> <- <<R2>>; R2 <- <R2> + 1; R1:R0 <- <R1:R0> + 1
0 * | MAR <- uROM; ADR+
1 * | A <- SRAM
2 * | SRAM <- A+1
3 * | MAR <- A
4 * | B <- SRAM
5 * | MAR <- uROM; ADR+
6 * | A <- SRAM
7 * | SRAM <- A+1; CC
8 * | MAR <- uROM; ADR+
9 * | DRAM <- A
A * | DRAM <- SRAM
B * | DRAM <- B
C * | A <- SRAM; CC=!C
D 0 | SRAM <- A+1; LDOP; ADR+
D 1 | SRAM <- A; LDOP; ADR+

|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
|| Nanocode Program Counter Instructions
||
|| Convention: prefaced with "pc".
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

0xB0 = pcfetch1(x)
| Fetches one byte from <PC> to SRAM<x>.
0 * | MAR <- uROM; ADR+
1 * | DRAM <- PCL
2 * | DRAM <- PCH
3 * | SRAM <- DRAM; LDOP; ADR+

0xB1 = pcfetch2(x, y)
| Fetches two bytes from <PC> to SRAM<x>,SRAM<y>.
0 * | MAR <- uROM; ADR+
1 * | DRAM <- PCL
2 * | DRAM <- PCH
3 * | SRAM <- DRAM
4 * | MAR <- uROM; ADR+
5 * | DRAM <- PCL
6 * | DRAM <- PCH
7 * | SRAM <- DRAM; LDOP; ADR+

0xB2 = pcstore(x, y)
| Stores the (2-byte) PC into SRAM<x>,SRAM<y>.
0 * | MAR <- uROM; ADR+
1 * | SRAM <- PCL; LDGR1
2 * | MAR <- uROM; ADR+
3 * | SRAM <- PCH; LDGR2
4 * | PCL <- GR1
5 * | PCH <- GR2; LDOP; ADR+

0xB3 = spload(x, y)
| Loads the PC: (PClo, PChi) <- (SRAM<x>, SRAM<y>)
0 * | MAR <- uROM; ADR+
1 * | PCL <- SRAM
2 * | MAR <- uROM; ADR+
3 * | PCH <- SRAM; LDOP; ADR+

0xB4 = pcpush
| Pushes the PC onto the stack
0 * | DRAM <- SPa
1 * | DRAM <- SPb
2 * | DRAM <- PCL; LDGR1
3 * | SPa <- SPa+1; CC=SP!C
4 0 | SPb <- SPb+1
4 1 | NOOP
5 * | DRAM <- SPa
6 * | DRAM <- SPb
7 * | DRAM <- PCH; LDGR2
8 * | SPa <- SPa+1; CC=SP!C
9 0 | SPb <- SPb+1
9 1 | NOOP
A * | PCL <- GR1
B * | PCH <- GR2; LDOP; ADR+

0xB5 = pcpop
| Pops two bytes off the stack into <PCH, PCL>
0 * | SPa,DRAM <- SPa-1; CC=SP!C
1 1 | SPb,DRAM <- SPb-1
1 0 | DRAM <- SPb
2 * | PCH <- DRAM
3 * | SPa,DRAM <- SPa-1; CC=SP!C
4 1 | SPb,DRAM <- SPb-1
4 0 | DRAM <- SPb
5 * | PCL <- DRAM; LDOP; ADR+

0xFF = bpt() 
| a do-nothing opcode which has been put in to allow explicit
| breakpoints in the simulator.
0 *  | NOOP; LDOP; ADR+

0xFE = ldspb(x)
| Load GR1 with the constant x.
0 * | SPb <- uROM; ADR+
1 * | noop; ADR+; LDOP
