#!/mit/watchmaker/@sys/perl

# $Id: nasm.pl,v 1.10 90/05/06 18:12:18 marc Exp Locker: marc $
# $Author: marc $

%from = (
	'SWT',	'0000',
	'UROM',	'0001',
	'SRAM',	'0010',
	'DRAM',	'0011',
	'I/O',	'0100',
	'ALU',	'0101',
	'SP',	'0110',
	'PCL',	'1000',
	'PCH',	'1001',
	'GR1',	'1010',
	'GR2',	'1011',
);

%to = (
	'I/O',		'0000',
	'ADR',		'0001',
	'A',		'0010',
	'B',		'0011',
	'SRAM',		'0100',
	'MAR',		'0101',
	'DRAM',		'0110',
	'I/OADR',	'0111',
	'SPA',		'1000',
	'SPB',		'1001',
	'SPA,DRAM',	'1010',
	'SPB,DRAM',	'1011',
	'PCL',		'1100',
	'PCH',		'1101',
	'NOOP',         '1111',
);

%aop = (
	'0',    	'0011 11',
	'FF',   	'1100 11',
	'0X00',		'0011 11',
	'0XFF',		'1100 11',
	'A',		'1111 11',
	'B',		'1010 11',
	'A+1',		'0000 00',
	'A-1',		'1111 10',
	'A+B',		'1001 10',
	'A-B',		'0110 00',
	'A+A',  	'1100 10',
	'A+A+1',	'1100 00',
	'A-B-1',	'0110 10',
	'A&B',  	'1011 11',
	'A|B',  	'1110 11',
        'A XOR B', 	'0110 11',
	'NOT A',	'0000 11',
        'A+B+1',	'1001 00',
	# can fit as many more as we need
);

%spop = (
	'SPA',	'1111 11',
	'SPB',	'1010 11',
	'SPA+1','0000 00',
	'SPA-1','1111 10',
	'SPB+1','1001 00', # when SPa = 0x00
	'SPB-1','1011 10', # when SPa = 0xFF
	# can fit as many more as we need
);

%wire = ( # warning!  magic numbers here....
	'LDOP',		0x20,
	'ADR+',		0x10,
	'!REFR',	0x08,
	'CC',		0x04,
	'LATCHCC',	0x04,
	'LDGR1',	0x02,
	'LDGR2',	0x01,
	# limited by hardware
);

%cc = (
	'N',	'000',
	'!C',	'001',
	'E',	'010',
	'D0',	'011',
        'P0',   '100',
        'P1',   '101',
	'I/O',	'110',
	'SP!C', '111',
);

@bin = ( # translate table
	'0000','0001','0010','0011',
	'0100','0101','0110','0111',
	'1000','1001','1010','1011',
	'1100','1101','1110','1111'
);

$lose = <<EOC;

ROM encoding:

ROM:

.-------------------.
|     DATA BUS      |
|---------.---------|
|  DRSEL  |  LDSEL  |
| 3 2 1 0 | 3 2 1 0 |
`---------^---------'

.----------------------.
|         ALU          |
|---------.-----.------|
|   fct   | !C  | Mode |
| 3 2 1 0 | Bit | Bit  |
`---------^-----^------'

.----------------------.
|          SP          |
|---------.-----.------|
|   fct   | !C  | Mode |
| 3 2 1 0 | Bit | Bit  |
`---------^-----^------'

.-------..-------..-------..-------..-------..-----------.
|  1/0  ||  1/0  ||  1/0  ||  1/0  ||  1/0  ||   CC SEL  |
|-------||-------||-------||-------||-------||-----------|
|  ADR+ || !REFR || LATCH || LDGR1 || LDGR2 ||    bit    |
|       ||       ||   CC  ||       ||       ||  2  1  0  |
`-------'`-------'`-------'`-------'`-------'`-----------'

EOC

$opcode = '????????';

$oldccsel = "000";  #init value

while (<>) {

	chop;
	do chopws($_);

	if (/^(0x|)([0-9a-fA-f]{2})\s*=\s*/) {
		($hex,$str) = ($2,$');
		$opcode = do hextobin($hex);
		print "| ",$str,"\n";
	} elsif (/^\s*([01\*]{8}\s+|(0x|)[0-9a-fA-F]{2}\s+|)([01\*]{4}|(0x|)[0-9a-fA-F])\s+([01\*])\s*\|\s*/) {
		($opc,$phase,$cc,$text) = ($1,$3,$5,$');
		$stest = $opc.$phase;
		if ($stest =~ /\*/) {
			$asgn = "==";
		} else {
			$asgn = "=";
		}
#		($a,$b,$c,$d,$e,$f) = ($1,$2,$3,$4,$5,$6);
		do chopws($opc);
#		printf("``%s'' ``%s'' ``%s'' ``%s'' ``%s'' ``%s''\n",
#			$opc,$b,$phase,$d,$cc,$f);
		if (length($opc) == 0) {
			$opc = $opcode;
		} elsif (length($opc) < 5) {
			$opc = do hextobin($opc);
		}
		if (length($phase) < 4) { $phase = do hextobin($phase); }
		if ($text =~ /[ \t]*#/) {
			($code,$comment) = ($`,$');
		} else {
			($code,$comment) = ($text,"");
		}
		$inst = do codetobin($code);
		printf("  %s %s %s  %s %s  | %s %s\n",
			$opc,$phase,$cc,$asgn,$inst,$code,$comment);
#	} elsif (/^\s*([01\*]{4}|[0-9a-fA-F])\s+([01\*])\s*\|\s*/) {
#		($phase,$cc,$code) = ($1,$2,$');
#		if (length($phase) == 1) { $phase = do hextobin($phase); }
#		$inst = do codetobin($code);
#		printf("  %s %s %s  = %s  | %s\n",
#			$opcode,$phase,$cc,$inst,$code);
	} elsif (/^\|\|LABELS/) { # Magic!!!
		print <<EOL;
|                                                        ! LL   
|               C                L              M    M  AR DD   
|               o                D              o    o  DELGG CC 
|  OPCODE  CLOK n ==  LD   DR   NO ALU  !d      SP  !d  RFCRR SEL
| 76543210 3210 d    3210 3210  CP FUNC Ce  NC FUNC Ce  +RC12 210
EOL
	} elsif (($_ eq "") || (/^\|/)) {
		print $_,"\n";
	} else {
		do error("syntax",$_);
	}
}

sub hextobin {
	if (length($_[0]) == 0) { return("");}
	$_[0] =~ /^(0x|)(.)/;
	return($bin[oct("0x".$2)].do hextobin($'));
}

sub inttobin { ((@_[0]==0)?('0'):('1')); }
sub chopws { @_[0] =~ /\s*$/; @_[0] = $`;}

sub codetobin {
	local($drsel,$ldsel,$alu,$sp,$ccsel,$wires);

	# Initialize $wires to 0x24 so that LdOp and LatchCC default to 1.
   	# This is because they are both active low signals.
	# THIS IS A MAGIC NUMBER THAT OUGHT TO BE ABSTRACTED.
	($drsel,$ldsel,$alu,$sp,$ccsel,$wires) =
		("0000","0000","1111 11","0000 00",$oldccsel,
		 $wire{'LDOP'}+$wire{'LATCHCC'});

	foreach $act (split(/\s*;\s*/,$_[0])) {
		$act =~ tr/a-z/A-Z/;  # upcase
		if ($act eq "NOOP") { $act = "A <- A"; }
		if (defined $wire{$act}) {
			# Deal with the active low wires
			# XXX HACK HACK HACK
			$wires ^= $wire{$act};
		} elsif ($act =~ (/\s*CC\s*=\s*/)) {
			if (defined $cc{$'}) {
				$ccsel = $cc{$'};
				$oldccsel = $ccsel;
			} else {
				do error("ccsel",$');
			}
		} elsif ($act =~ (/\s*((->)|(<-))\s*/)) {
			if ($1 eq "->") {
				($src,$dst) = ($`,$');
			} else {
				($dst,$src) = ($`,$');
			}

			if (defined $from{$src}) {
				$ldsel = $from{$src};
			} elsif (defined $aop{$src}) {
				# assume ALU
				$alu = $aop{$src};
				$ldsel = $from{'ALU'};
			} elsif (defined $spop{$src}) {
				# assume SP
				$sp = $spop{$src};
				$ldsel = $from{'SP'};
			} elsif ($from =~ /^ALU\((.*)\)$/) {
				if (defined $aop{$1}) {
					$alu = $aop{$1};
				} else {
					split(/,/,$1);
					$alu = @_[0].' '.@_[1,2];
				}
				$ldsel = $from{'ALU'};
			} elsif ($from =~ /^SP\((.*)\)$/) {
				if (defined $aop{$1}) {
					$sp = $aop{$1};
				} else {
					split(/,/,$1);
					$sp = @_[0].' '.@_[1,2];
				}
				$drsel = $from{'SP'};
			} else {
				do error("source",$src);
			}

			if (defined $to{$dst}) {
				$drsel = $to{$dst};
			} else {
				do error("destination",$act);
			}
		} else {
			do error("action",$act);
		}
	}

	return(sprintf("%s %s  0%s %s  00 %s  %s%s %s",
		$drsel,$ldsel,do inttobin($wires >> 5),$alu,$sp,
		do inttobin(($wires >> 4) & 0x01),$bin[$wires & 0x0f],
		$ccsel));
}

sub error { print STDERR "| nasm, line $.: ".$_[0]." error: ".$_[1]."\n"; }
