/* Q&D Hack whilst awaiting a real dram simulation
 */

#include "sim.h"

#define MAX_CYCLES 800  /* 1.25 ms */
static int refresh_data[256];

InitRefreshState()
{
     bzero((char *) refresh_data, sizeof(refresh_data));
}

RefreshRow()
{
     static int row = 0;

     refresh_data[row] = Time;
     row = (row + 1) % 256;
}

load_dram(name)
   char *name;
{
     char buf[1024];
     int fid = open(name, 0), k;
     register int i=0, j;
     
     if (fid < 0)
	  error("Can't read DRAM file %s", name);

     while ((k = read(fid, buf, 1024)) > 0) {
	  for (j=0; j<k; )
	       WDRAM(i++, buf[j++]);
     }
     close(fid);
     Msg("%d DRAM bytes initialized.", i);
}

w_dram(value)
   int value;
{
     static unsigned state, adr;
     static long lastime = -2;
     
     if (Time != ++lastime) {
	  state = 0;
	  lastime = Time;
     }
     else ++state;
     
     value &= 0xFF;
     switch(state) {
     default:
     case 0:
	  /* Do refreshing first */
	  if (Time - refresh_data[value] > MAX_CYCLES) {
	       GoFlag = 0;
	       Msg("Warning!  DRAM row %d failed refresh-check.", value);
	  }
	  refresh_data[value] = Time;
	  DRAM_row = value;
	  state = 0;
	  return;
	  
     case 1:
	  DRAM_col = value;
	  adr = DRAM_row | (DRAM_col << 8);
	  DRAMreg = RDRAM(adr);
	  return;
	  
     case 2:
	  WDRAM(adr, value);
	  return;
     }
}
