extern char Level;		/* Simulation (display) level:
				 * 0:	No display
				 * 1:	switches
				 * 2:	microcode level
				 * 3:	nanocycle */

extern unsigned char dram[DRAMSIZE];	/* 64K x 8 dynamic ram */
extern struct Display *RADpy, *RBDpy, *CCDpy, *ALUoutDpy, *OpDpy,
     *AdrDpy, *URomDpy, *PhDpy, *BusDpy, *MarDpy, *DregDpy, *SwtDpy,
     *TimDpy, *CtlDpy, *UcntDpy, *SPoutDpy, *PCoutDpy, *GR1Dpy,
     *GR2Dpy, *CCbitDpy;

extern char GoFlag,		/* Nonzero iff machine running.	*/
     UIDpy,			/* Microinstruction display */
     SymFlag,			/* Symbolic tag printout */
     DpyFlag;			/* Enable state display.	*/

/* the various data path elements */
extern unsigned char ctl_rom_0[ROMSIZE];	/* control roms */
extern unsigned char ctl_rom_1[ROMSIZE];
extern unsigned char ctl_rom_2[ROMSIZE];
extern unsigned char ctl_rom_3[ROMSIZE];
extern unsigned char ucode_rom[ROMSIZE];	/* microcode rom on bus */
extern unsigned char sram[SRAMSIZE];	/* ram for registers and memory */

extern int sram_mar;		/* sram address register */
extern int ucode_hi;		/* ucode rom address register - high byte */
extern int ucode_lo;		/* ucode rom address register - low byte */
extern int opcode;		/* op code register */
extern int RegA;		/* accumulator A */
extern int RegB;		/* accumulator B */
extern int CCReg, CCsel, Latch;	/* condition code register */
extern int switches;		/* switches */
extern int phase, pRCO;		/* instruction phase - 4 bits, and RCO */
extern long ctlin;		/* Control ROM inputs	*/
extern int DRAMreg;		/* DRAM register */
extern int DRAM_row;		/* DRAM row address */
extern int DRAM_col;		/* DRAM column address */
extern int ALU_data, ALU_flags;	/* ALU output registers --
 				 * ALU_flags: X X X X ALU0 Z C N  */
extern int ALU_c_out;		/* ALU carry out */
extern long Time;		/* Count of nanocycles executed */
extern long UIcount;		/* Count of uInstrs executed	*/
extern int ctl_out_0, ctl_out_1, ctl_out_2, ctl_out_3;	/* ctl rom outputs */
extern int src,dst,alu,inca,cc,cust;	/* signals decoded from ctl rom */
extern int BreakPt;		/* Current breakpoint adr	*/
extern int WindY;		/* Current output line.	*/
extern int NRefr;		/* Hardware refresh bit */
extern int LdOp;		/* Load Opcode bit */

/* Stack pointer */
extern int SPa, SPb;		/* RegA and RegB of stack alu */
extern int sptr;		/* Stack ALU control bits */
extern int LdSPa, LdSPb;	/* Load bits for stack alu */
extern int SP_data;		/* Output of stack ALU */
extern int SP_carry;		/* Whether last SPa produced carry */

/* Program counter */
extern int PClo, PChi;		/* Low and high bits of PC */
extern int PCcarry;		/* whether PClo flipped last tick */

/* General registers */
extern int GR1, GR2, LdGR1, LdGR2;
