#define ROMSIZE 8192
#define SRAMSIZE 256
#define DRAMSIZE 65536L

#define	UPDPY(DD,XX) ((DD) ? UpDpy(DD, (unsigned long) (XX)) : (XX))

#define	RDRAM(ADR)     dram[(unsigned) (ADR)]
#define	WDRAM(ADR,VAL) dram[(unsigned) (ADR)] = (VAL)

/* macro which combines the two 8 bit ucode registers into one */
#define ucode_mar ((unsigned) ((ucode_hi & 0x1F) << 8) + (ucode_lo & 0xFF))

/* macro which combines DRAM row and column regs into one */
#define DRAM_addr (((DRAM_row & 0xFF) << 8) + (DRAM_col & 0xFF))

/* macro which combines the two ctl rom output regs into one */
#define ctl_out_32 ((unsigned long) ((ctl_out_3 & 0xFF) << 24) + \
		    ((ctl_out_2 & 0xFF) << 16) + ((ctl_out_1 & 0xFF) << 8) + \
		    (ctl_out_0 & 0xFF))

char *UserValue(), *UserInput(), *bin();

#include "sim-proto.h"
#include "sim-globals.h"
