#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>

/* Prototype routines to access .map file:
 */

FILE *MapFid = NULL;
int MapLine;			/* Last line accessed, or -1.	*/
char SourceLine[100];		/* Current source line.		*/

#define SLINES 2000	/* Maximum number of source lines	*/

struct SrcMap {
     unsigned short offset;	/* Byte offset of line in source file	*/
     unsigned short codeadr;	/* uROM adr of code for this line	*/
} map[SLINES];
int MaxLines;		/* Number of lines in source file.	*/

/*
 * Open map file, turn on source mapping iff successful.
 */
mapopen(name)
   char *name;
{
     char filename[100];
     int i;
     
     strcpy(filename, name);
     strcat(filename, ".map");
     if ((MapFid=fopen(filename, "r")) == NULL) return;
     MaxLines = fread(map, sizeof map[1], SLINES, MapFid);
     fclose(MapFid);
     
     for (i = 0; i < MaxLines; i++) {
	  map[i].offset = ntohs(map[i].offset);
	  map[i].codeadr = ntohs(map[i].codeadr);
     }
     
     strcpy(filename, name);
     strcat(filename, ".uasm");
     if ((MapFid=fopen(filename, "r")) == NULL) return;
     
     MapLine = -1;
}

/*
 * Show source line for uROM location adr.
 * Ignores call iff no mapping (eg, if couldn't find .map file).
 * Ignores call iff same source line as last call.
 * Otherwise, calls ShowSrc(cc, adr) where cc is pointer to text string
 *   (null terminated, no newline).
 */

Source(adr)
   unsigned adr;
{
     register ch, i;
     
     if (MapFid == NULL) return;
     if (MapLine == -1) {
	  MapLine = 0;
	  goto search;
     }
     
     if ((adr >= map[MapLine].codeadr) && (adr <  map[MapLine+1].codeadr))
	  return;
     
search:
     
     for (;;) { 
	  if (adr < map[MapLine].codeadr) {
	       if (MapLine == 0) break;
	       MapLine--;
	       continue;
	  }
	  if (MapLine >= (MaxLines-1)) break;
	  if (adr >= map[MapLine+1].codeadr) {
	       MapLine++;
	       continue;
	  }
	  break;
     }

     fseek(MapFid, (long) map[MapLine].offset, 0);
     for (i=0; ((ch=getc(MapFid)) != EOF) && (ch != '\n'); )
	  SourceLine[i++] = ch;
     SourceLine[i] = 0;
     ShowSrc(SourceLine, adr, MapLine);
}

/* ARGSUSED */
ShowSrc(cc, adr, line)
   char *cc;
   unsigned adr;
   int line;
{
     DpyCLine(0, 21);
     if (!cc) return;
     MapLine = -1;
     
     DpyText(0, 21, cc, line);
}

/* Display text from source file:
 * expands tabs.				*/

DpyText(x, y, cc, line)
   int x, y, line;
   register char *cc;
{
     register i=0;
     char nbuf[100], *buf, ch;
     
     nbuf[3] = '|';
     nbuf[2] = '0' + line%10;	line /= 10;
     nbuf[0] = nbuf[1] = ' ';
     if (line)	{ nbuf[1] = '0' + line%10;	line /= 10; }
     if (line)	{ nbuf[0] = '0' + line%10; }
     buf = nbuf+4;
     
     while (*cc) switch(ch = *cc++)
	  { case '\t':	do buf[i++] = ' '; while (i & 7);
	       continue;
	  default:	if (i < 76) buf[i++] = ch;
	  }
     buf[i] = 0;
     DpyRev(x, y, buf);
}
