/* VERY ad-hoc means to display interesting SRAM locations:
 */

#include <stdio.h>
#include "sim.h"

char wmemo[256];

extern WindTop, WindBot;
char watflag;			/* 0 to force update, else 1.		*/
int watx, waty;

wat4(adr, name)
   int adr;
   char *name;
{
     char buf[100];
     
     if (watflag) {
	  if ((sram[adr] == wmemo[adr]) &&
	      (sram[adr+1] == wmemo[adr+1]) &&
	      (sram[adr+2] == wmemo[adr+2]) &&
	      (sram[adr+3] == wmemo[adr+3])) goto skipit;
     }
     
     sprintf(buf, "%s: %2x %2x %2x %2x", name,
	     sram[adr]&0xFF,
	     sram[adr+1]&0xFF,
	     sram[adr+2]&0xFF,
	     sram[adr+3]&0xFF);
     DpyRev(watx, waty, buf);
     wmemo[adr] = sram[adr];
     wmemo[adr+1] = sram[adr+1];
     wmemo[adr+2] = sram[adr+2];
     wmemo[adr+3] = sram[adr+3];
     
skipit:
     waty++;
     if (waty > WindBot) {
	  waty = WindTop;
	  watx = 40;
     }
}

watch()
{
     int a;
     if (!watflag) WindClr();
     watx = 0;	waty = WindTop;
     
     a = 32;
     
     wat4(a, "   B");
     wat4(a += 5, " Op1");
     wat4(a += 4, " Op2");
     wat4(a += 4, " Op3");
     wat4(a += 4, " Op4");
     wat4(a += 4, " Op5");
     wat4(a += 4, " Op6");
     
     wat4(0, "0123");
     wat4(4, "4567");
     watflag = 1;
}

/* An even more ad-hoc top-of-stack display */
display_TOS()
{
     int i;
     unsigned short index;

     index = (SPb << 8) + SPa - 1;

     for (i=0; i<4; i++) {
	  DpyMov(4, 15+i);
	  printf("0x%04x = %02x, %-5d", index, (int) dram[index] == -1 ?
		 0xFF : (dram[index] & 0xFF), dram[index]);
	  index -= 1;
	  fflush(stdout);
     }

     for (i=0; i<4; i++) {
	  DpyMov(25, 15+i);
	  printf("0x%04x = %02x, %-5d", index, (int) dram[index] == -1 ?
		 0xFF : (dram[index] & 0xFF), dram[index]);
	  index -= 1;
	  fflush(stdout);
     }

     for (i=0; i<4; i++) {
	  DpyMov(46, 15+i);
	  printf("0x%04x = %02x, %-5d", index, (int) dram[index] == -1 ?
		 0xFF : (dram[index] & 0xFF), dram[index]);
	  index -= 1;
	  fflush(stdout);
     }
}
