/****************************************************************/
/* Instruction Word Organization:				*/
/*   conditional statements		iiiiuccc aaaaaaaa	*/
/*   immediate data statement		iiiissss vvvvvvvv	*/
/*   assertion statements		iiiissss ssssssss	*/
/*    where i = opcode selection				*/
/*          u = unconditional bit				*/
/*          c = status selection				*/
/*          a = alternative address, i.e. jump address		*/
/*	    v = immediate values, i.e. binary data		*/
/*          s = assertion signals				*/
/****************************************************************/

/* $Id: lab4.sp,v 1.5 91/11/07 00:19:04 bjaspan Exp Locker: bjaspan $ */
/* $Source: /afs/athena.mit.edu/user/b/bjaspan/classes/6111/lab4/RCS/lab4.sp,v $ */

op <15:0>;			/* Indicates the available bits		     */
address op <7:0>;		/* Indicates bit locations for addresses     */
value op <7:0>;			/* Indicates bit locations for immediate val */

/* Instruction Set of AM29C10A */
RESET	op<15:12>=%b0000;	/* Jump Zero (RESET)			     */
CJSB	op<15:12>=%b0001;	/* Cond Jump to SuBroutine		     */
CJMP	op<15:12>=%b0011;	/* Cond JuMP				     */
PUSH	op<15:12>=%b0100;	/* PUSH stack down / cond load counter	     */
CJSRP	op<15:12>=%b0101;	/* Cond Jump to Subroutine via Register Pipe */
CJRP	op<15:12>=%b0111;	/* Cond Jump via Register Pipeline	     */
RFCT	op<15:12>=%b1000;	/* Repeat loop with File when CounTer != 0   */
RPCT	op<15:12>=%b1001;	/* Repeat loop with Pipeline when CounTer!=0 */
CRTN	op<15:12>=%b1010;	/* Cond ReTurN				     */
CJPP	op<15:12>=%b1011;	/* Cond Jump Pipeline and Pop		     */
LDCT	op<15:12>=%b1100;	/* LoaD CounTer				     */
LOOP	op<15:12>=%b1101;	/* test end-of-LOOP			     */
DO	op<15:12>=%b1110;	/* continue, DO the assertions		     */
TWB	op<15:12>=%b1111;	/* Three-Way-Branch			     */

/* Unconditional jump statements */
JSB	op<15:11>=%b00011;	/* Jump to SuBroutine			     */
JMP	op<15:11>=%b00111;	/* JuMP					     */
JSRP	op<15:11>=%b01011;	/* Jump to Subroutine via Register Pipeline  */
JRP	op<15:11>=%b01111;	/* Jump via Register Pipeline		     */
RTN	op<15:11>=%b10101;	/* ReTurN				     */
JPP	op<15:11>=%b10111;	/* Jump Pipeline and Pop		     */

/* things to make code more readable */
if	nop;
true	op<11>=1;		/* This makes sure /CCEN is deasserted	     */

/*
 * Assertions
 * Note that only three signals can be asserted along with immed,
 * since the rest of the bits are treated as an address for the value
 * ROM.  This is fine, since CMPLOAD is the only signal ever asserted
 * with immed.
 */
immed		op<11>=1;	/* Output immediate data onto the Data Bus   */
LDCMP		op<10>=1;	/* Load the comparison register */
LDSRAM		op<09>=1;	/* load SRAM from bus */
LDACCUM		op<08>=1;	/* Perform one accumulation */
LDADDREG	op<07>=1;	/* Load accumulation register */
RDAV		op<05>=1;	/* trash UART data, common with LDDCNT */
LDDCNT		op<05>=1;	/* load duration counter, common with RDAV */
DRCHAR		op<04>=1;	/* drive UART data onto bus */
CLRMAR		op<03>=1;	/* reset MAR, drive SWT */
DRSWT		op<03>=1;	/* reset MAR, drive SWT */
MARCNT		op<02>=1;	/* increment MAR */
DRSRAM		op<01>=1;	/* drive SRAM onto bus */
CLRCKSUM	op<00>=1;	/* Reset checksum to zero */

/* Status signals */
/DAVS		op<10:8>=0;	/* Data not AVailable at UART (synchronized) */
/CKSUM_ZERO	op<10:8>=1;	/* The checksum is not currently zero */
/EQUAL		op<10:8>=2;	/* value in cmpreg != bus on previous cycle */
/PE		op<10:8>=4;	/* No parity error from UART */
/FE		op<10:8>=5;	/* No framing error from UART */
/OR		op<10:8>=6;	/* No overrun error from UART */
