#!/afs/athena/contrib/perl/perl

# Creates crom.dat and crom.lst from crom.

open(INP, "crom.trn") || die "Cannot open crom: $!";
open(DAT, ">crom.dat") || die "Cannot open crom.dat: $!";
open(LST, ">crom.lst") || die "Cannot open crom.lst: $!";

print DAT "#SET_ADDRESS=0;\n#LOAD_ADDRESS=0;\n";

while (<INP>) {
    (print(LST $_), next) if (/^\#/ || $_ eq "\n");
    
    chop;
    @_ = grep($_ ne "", split);
    foreach (@_) {
	if ($_ =~ /^\d+$/) {
	    $out = sprintf("%02x\n", $_);
	} elsif ($_ =~ /^(-?)(\d+)(\.\d+)$/) {
	    $val = (($2 << 8) + int($3*256)) * ($1 eq "-" ? -1 : 1);
	    $out = sprintf("%02x\n%02x\n", ($val >> 8) & 0xff, $val & 0xff);
	} else {
	    print STDERR "Unknown value: \"$_\"\n";
	    next;
	}

	$ldata .= $out;
	print DAT $out;
    }

    $ldata =~ tr/\n/  /;
    printf(LST "%02x\t%s\n", $addr, $ldata);
    $addr += length($ldata) / 3;
    $ldata = "";
}

close(INP);
close(DAT);
close(LST);

