/*
 * $Id: math2.as,v 1.4 91/12/12 01:57:42 bjaspan Exp Locker: bjaspan $
 * $Source: /afs/athena.mit.edu/user/b/bjaspan/classes/6111/project/math/RCS/math2.as,v $
 */

# SPEC_FILE = math.sp;
# LIST_FILE = math2.lst;
# MASK_COUNT = 8;
# SET_ADDRESS = 0;
# LOAD_ADDRESS = 200;

render_rtn:
	/*
	 * For each edge <a, b>:
	 * o r1 = int(obj[a].x), r2 = int(obj[b].x)
	 * o TMP1 = int(obj[a].y), TMP2 = int(obj[b].y)
	 * o TMP3 = r2 - r1 (dx)
	 * o TMP4 = |TMP3|
	 * o TMP5 = TMP2 - TMP1 (dy)
	 * o TMP6 = |TMP5|
	 * o r3 = TMP6 > TMP4
	 * o xmit r3
	 * o xmit r1 + 128
	 * o xmit TMP4
	 * o xmit TMP3 > 0
	 * o xmit TMP1 + 128
	 * o xmit TMP6
	 * o xmit TMP5 > 0
	 * o r1 = TMP4 (|dx|), r2 = TMP6 (|dy|)
	 * o if (r2 > r1)
	 * o    xmit r2 - r1
	 * o    xmit r1 - 0.5r2
	 * o else
	 * o    xmit r1 - r2
	 * o    xmit r2 - 0.5r1
	 */
	LDMAR NUM_EDGE;
	LDREG r1 DRSRAM;
	LDMAR TMP7;
	LDSRAM DRREG r1;

	LDMAR TMP8;
	LDSRAM EDGE_LIST;

	/* Tell the video unit to clear the screen */
	LDOUT 0;
	LDREG r4 x1;
	jmp xmit_byte;
x1:
	noop;

render_loop:
	LDMAR TMP7;
	LDA DRSRAM;
	LDB 1;
	LDSRAM subc;
	if carry cjmp compute_edge;

	jmp render_object_return_2;

compute_edge:
	/* Tell the video unit a line is coming */
	LDOUT 1;
	LDREG r4 x2;
	jmp xmit_byte;
x2:

	/* <TMP8> points to the current edge */
	/* a vertex begins a sram 2:edge*8 */
	LDA 8;
	LDB 0;
	LDY;
	
	/* r1 = int(obj[a].x), TMP1 = int(obj[a].y) */
	LDMAR TMP8;
	LDMAR DRSRAM;
	LDA DRSRAM;
	LDX;
	LDMPR 2;
	LDMAR DRPR_HI;
	LDREG r1 DRSRAM MARCNT;
	do MARCNT;
	LDREG r3 DRSRAM;
	LDMPR 0;
	LDMAR TMP1;
	LDSRAM DRREG r3;

	/* r2 = int(obj[b].x), TMP2 = int(obj[b].y) */
	LDMAR TMP8;
	LDMAR DRSRAM;
	do MARCNT;
	LDA DRSRAM;
	LDX;
	LDMPR 2;
	LDMAR DRPR_HI;
	LDREG r2 DRSRAM MARCNT;
	do MARCNT;
	LDREG r3 DRSRAM;
	LDMPR 0;
	LDMAR TMP2;
	LDSRAM DRREG r3;

	/* TMP3 = r2 - r1 */
	LDA DRREG r2;
	LDB DRREG r1;
	LDMAR TMP3;
	LDSRAM subc;

	/* TMP4 = |TMP3| */
	LDB DRSRAM;
	LDREG r4 render_rtn_1;
	jmp abs_value;
render_rtn_1:
	LDMAR TMP4;
	LDSRAM a;

	/* TMP5 = TMP2 - TMP1 */
	LDMAR TMP2;
	LDA DRSRAM;
	LDMAR TMP1;
	LDB DRSRAM;
	LDMAR TMP5;
	LDSRAM subc;

	/* TMP6 = |TMP5| */
	LDB DRSRAM;
	LDREG r4 render_rtn_2;
	jmp abs_value;
render_rtn_2:
	LDMAR TMP6;
	LDSRAM a;

	/* r3 = TMP6 > TMP4 */
	LDMAR TMP6;
	LDA DRSRAM;
	LDMAR TMP4;
	LDB DRSRAM;
	latch;
	if carry cjmp dy_greater;
	LDREG r3 0;
	jmp render_xmit;
dy_greater:
	LDREG r3 1;
	jmp render_xmit;

render_xmit:
	LDOUT DRREG r3;
	LDREG r4 x3;
	jmp xmit_byte;
x3:

	LDA DRREG r1;
	LDB 128;
	LDOUT add;
	LDREG r4 x4;
	jmp xmit_byte;
x4:

	LDMAR TMP4;
	LDOUT DRSRAM;
	LDREG r4 x5;
	jmp xmit_byte;
x5:

	LDMAR TMP3;
	LDA 128;
	LDB DRSRAM;
	latch;
	if carry cjmp dx_positive;
	LDOUT 0;
	jmp dx_done;
dx_positive:
	LDOUT 1;
dx_done:
	LDREG r4 x6;
	jmp xmit_byte;
x6:

	LDMAR TMP1;
	LDB DRSRAM;
	LDA 96;
	LDOUT add;
	LDREG r4 xFROB;
	jmp xmit_byte;
xFROB:

	LDMAR TMP6;
	LDOUT DRSRAM;
	LDREG r4 x7;
	jmp xmit_byte;
x7:

	LDMAR TMP5;
	LDA 128;
	LDB DRSRAM;
	latch;
	if carry cjmp dy_positive;
	LDOUT 0;
	jmp dy_done;
dy_positive:
	LDOUT 1;
dy_done:
	LDREG r4 x8;
	jmp xmit_byte;
x8:

	/* Set up Y register for multiply */
	LDA 0;
	LDB 128;
	LDY;

	/* r1 = TMP4 (|dx|), r2 = TMP6 (|dy|) */
	LDMAR TMP4;
	LDREG r1 DRSRAM;
	LDMAR TMP6;
	LDREG r2 DRSRAM;
	LDA DRREG r2;
	LDB DRREG r1;
	latch;
	if carry cjmp cmp_dy_greater;
cmp_dx_greater:
	LDA DRREG r1;
	LDB DRREG r2;
	LDOUT subc;
	LDREG r4 x9;
	jmp xmit_byte;
x9:
	LDA DRREG r1;
	LDB 0;
	LDX;
	LDA DRREG r2;
	LDB DRPR_HI;
	LDOUT subc;
	LDREG r4 x10;
	jmp xmit_byte;
x10:
	jmp xmit_done;
cmp_dy_greater:
	LDA DRREG r2;
	LDB DRREG r1;
	LDOUT subc;
	LDREG r4 x11;
	jmp xmit_byte;
x11:
	LDB 0;
	LDX;
	LDA DRREG r1;
	LDB DRPR_HI;
	LDOUT subc;
	LDREG r4 x12;
	jmp xmit_byte;
x12:
	jmp xmit_done;

xmit_done:
	/* Update TMP8 to point to next edge, loop */
	LDMAR TMP8;
	LDA DRSRAM;
	LDB 2;
	LDSRAM add;
	jmp render_loop;

/***********************************************************************
 * xmit_byte -- send the byte in the output register to the video unit,
 * using the DAV/ACK handshake protocol.
 ***********************************************************************/
xmit_byte:
	/* XXX remove for use with machines! */
	jmp DRREG r4;

	/* ACK_I and DAV_O start off unasserted. */

	do DAV_T;
xmit_ack_wait_1:
	if /ack_i cjmp xmit_ack_wait_1;
	
	/* ACK received, unassert DAV and wait for ACK to fall */
	do DAV_T;
xmit_ack_wait_2:
	if /ack_i cjmp xmit_unack;
	jmp xmit_ack_wait_2;
xmit_unack:
	/* ACK has been unasserted, so we're done */
	jmp DRREG r4;

/***********************************************************************
 * abs_value -- set A = |B|, return to r4
 ***********************************************************************/
abs_value:
	LDA 128;
	latch;
	LDA 0;
	if carry cjmp abs_noinvert;
	LDA subc;
	jmp abs_done;
abs_noinvert:
	LDA add;
abs_done:
	jmp DRREG r4;


# SET_ADDRESS = f6;
# LOAD_ADDRESS = 2f6;
render_object_entry_2:
	jmp render_rtn;

# SET_ADDRESS = f8;
# LOAD_ADDRESS = 2f8;
render_object_return_2:
	LDCSEG 0;
