/*
 * $Id: test.as,v 1.2 91/12/09 17:03:53 bjaspan Exp Locker: bjaspan $
 * $Source: /afs/athena.mit.edu/user/b/bjaspan/classes/6111/project/math/RCS/test.as,v $
 */
 
# SPEC_FILE = math.sp;
# LIST_FILE = test.lst;
# MASK_COUNT = 8;

# SET_ADDRESS = 0;
# LOAD_ADDRESS = 0;

start:
	noop;
	jmp main_loop;

main_loop:
	noop;
	noop;
	if /p0 cjmp main_loop;

p0_jump_wait:
	if /p0 cjmp DRSWT;
	jmp p0_jump_wait;

p0_release_wait:
	if /p0 cjmp main_loop;
	jmp p0_release_wait;

/***********************************************************************
 * load_a -- load switches into A
 * load_b -- load switches into B
 * load_x -- load A:B into X
 * load_y -- load A:B into Y
 * read_plo -- put low byte of product into B
 * read_phi -- put high byte of product into B
 * test_alu -- test all the ALU functions I care about
 ***********************************************************************/
load_a:
	if /p0 cjmp load_a;
	LDA DRSWT;
	jmp p0_release_wait;

load_b:
	if /p0 cjmp load_b;
	LDB DRSWT;
	jmp p0_release_wait;

load_x:
	do LDX;
	jmp p0_release_wait;

load_y:
	do LDY;
	jmp p0_release_wait;

read_plo:
	LDB DRMULT_LO;
	jmp p0_release_wait;

read_phi:
	LDB DRMULT_HI;
	jmp p0_release_wait;

test_alu:
	a;
	aplus1;
	add;
	addc;
	sub;
	subc;
	jmp p0_release_wait;
	
/***********************************************************************
 * load_mar -- load switches into MAR when p0 is pressed.
 *
 * load_mpr -- load switches (low nibble) into MPR when p0 is pressed
 * 
 * sram_write -- write switches into SRAM when p0 is pressed, and
 * increment MAR.
 * 
 * sram_read -- read a value from SRAM.  Address is switches when p0
 * is pressed.  Value is written into MAR (gack!).
 ***********************************************************************/
load_mar:
     	if /p0 cjmp load_mar;
	LDMAR DRSWT;
	jmp p0_release_wait;

load_mpr:
	if /p0 cjmp load_mpr;
	LDMPR DRSWT;
	jmp p0_release_wait;

sram_write:
	if /p0 cjmp sram_write;
	LDSRAM DRSWT;
	do MARCNT;
	jmp p0_release_wait;

sram_read:
	LDMAR DRSRAM;
	jmp p0_release_wait;

/***********************************************************************
 * test_pals -- twiddle every assertion PAL output bit and test the
 * inter-pal dependencies
 ***********************************************************************/
test_pals:
	/* drive signals */
	DRROM;
	DRALU;
	DRREG;
	DRPR_LO;
	DRPR_HI;
	DRSRAM;
	DRSWT;
	DRIN;

	/* load signals */
	do LDA;
	do LDB;
	do LDX;
	do LDY;
	do LDREG;
	do LDSRAM;
	do LDMAR;
	do LDMPR;
	do LDOUT;
	LDCSEG 0;

	/* control signals */
	do MARCNT;
	do Cin;
	do DRCONST;

	/* test   ACK_O	DAV_O	*/
	do CLR_T; /* 0	0	*/
	do ACK_T; /* 1	0	*/
	do DAV_T; /* 1	1	*/
	do ACK_T; /* 0	1	*/
	do DAV_T; /* 0	0	*/
	do ACK_T; /* 1	0	*/
	do DAV_T; /* 1	1	*/
	do CLR_T; /* 0	0	*/

	/* Test DR dep on CTRL -- no DR sigs during DRCONST */
	DRROM DRCONST;
	DRREG DRCONST;
	DRPR_LO DRCONST;
	DRSWT DRCONST;

	/* Test LD dep on CC -- no LD sigs during jumps */
	jmp test_ld_1 LDA;
test_ld_1:
	jmp test_ld_2 LDX;
test_ld_2:
	jmp test_ld_3 LDREG;
test_ld_3:
	jmp test_ld_4 LDMAR;
test_ld_4:

	/* Test CTL dep on DR -- no CTL sigs during jumps or DRROM */
	DRROM MARCNT;
	DRROM Cin;
	DRROM DRCONST; /* *neither* should be asserted! */

	/* test   	ACK_O	DAV_O	*/
	do CLR_T; /* 	0	0	*/
	do ACK_T; /* 	1	0	*/
	DRROM DAV_T; /* 1	0	*/ 
	DRROM ACK_T; /* 1	0	*/
	DRROM CLR_T; /* 1	0	*/

	jmp test_ctl_1;
test_ctl_1:
	jmp test_ctl_2;
test_ctl_2:

	/* test   		ACK_O	DAV_O	*/
	do CLR_T; /* 		0	0	*/
	do ACK_T; /* 		1	0	*/
	jmp test_ctl_3; /* 	1	0	*/
test_ctl_3:

	jmp p0_release_wait;

/***********************************************************************
 * test_cseg -- load the code segment register with 1.  The PC will then
 * wrap to 00 and execute the code in test1.as.
 ***********************************************************************/
# SET_ADDRESS = ff;
# LOAD_ADDRESS = ff;
test_cseg:
	LDCSEG 1;

# SET_ADDRESS = 0;
# LOAD_ADDRESS = 100;
	noop; /* unconfuse the assembler */

high_loop:
	do MARCNT;
	if /p0 cjmp high_loop;
	
high_wait:
	if /p0 cjmp exit_cseg;
	jmp high_wait;

# SET_ADDRESS = ff;
# LOAD_ADDRESS = 1ff;
exit_cseg:
	LDCSEG 0;
	/* PC wraps to 0x00 */

	



