/*
 * $Id: test0.as,v 1.2 91/12/09 17:38:43 bjaspan Exp Locker: bjaspan $
 * $Source: /afs/athena.mit.edu/user/b/bjaspan/classes/6111/project/math/RCS/test0.as,v $
 */
 
# SPEC_FILE = math.sp;
# LIST_FILE = test0.lst;
# MASK_COUNT = 8;

# SET_ADDRESS = 0;
# LOAD_ADDRESS = 0;

start:
	brk 10;
	noop;
	jmp main_loop;

main_loop:
	noop;
	noop;
	if /p0 cjmp main_loop;

p0_jump_wait:
	if /p0 cjmp DRSWT;
	jmp p0_jump_wait;

p0_release_wait:
	if /p0 cjmp main_loop;
	jmp p0_release_wait;

/***********************************************************************
 * test_crom -- drive the first few crom values onto the bus
 ***********************************************************************/
test_crom:
	LDA 0;
	LDB 10;
crom_loop:
	do DRCONST;
	LDA aplus1;
	latch;
	if /equal cjmp crom_loop;
	jmp p0_release_wait;

/***********************************************************************
 * test_regs -- load and drive all four registers
 ***********************************************************************/
test_regs:
	LDREG r1 %h11;
	LDREG r2 %h88;
	LDREG r3 %h55;
	LDREG r4 %hAA;
	DRREG r1;
	DRREG r2;
	DRREG r3;
	DRREG r4;
	jmp p0_release_wait;

/***********************************************************************
 * load_a -- load switches into A
 * load_b -- load switches into B
 * load_x -- load A:B into X
 * load_y -- load A:B into Y
 * read_plo -- put low byte of product into B
 * read_phi -- put high byte of product into B
 * test_alu -- test all the ALU functions I care about
 * test_mult -- test multiplier
 * add_sram --  SRAM<4:5> = SRAM<0:1> + SRAM<2:3>
 * mult_sram -- SRAM<4:5> = SRAM<0:1> * SRAM<2:3>
 ***********************************************************************/
load_a:
	if /p0 cjmp load_a;
	LDA DRSWT;
	jmp p0_release_wait;

load_b:
	if /p0 cjmp load_b;
	LDB DRSWT;
	jmp p0_release_wait;

load_x:
	do LDX;
	jmp p0_release_wait;

load_y:
	do LDY;
	jmp p0_release_wait;

read_plo:
	LDB DRPR_LO;
	jmp p0_release_wait;

read_phi:
	LDB DRPR_HI;
	jmp p0_release_wait;

test_alu:
	a;
	aplus1;
	add;
	addc;
	sub;
	subc;

	/* test the carry output */
	LDA 200;
	LDB 60;
	LDA add;
	if carry cjmp carry_passed_1;
	/* ERROR! */
	noop; 

carry_passed_1:
	LDA 100;
	LDA add;
	if carry cjmp carry_failed_1;
	jmp carry_passed_2;
carry_failed_1:
	/* ERROR! */
	noop;
carry_passed_2:

	/* test the equal output */
	LDA 75;
	LDB 75;
	latch;
	if /equal cjmp equal_failed_1;
	jmp equal_passed_1;
equal_failed_1:
	/* ERROR! */
	noop;
equal_passed_1:
	LDA 76;
	latch;
	if /equal cjmp equal_passed_2;
	/* ERROR! */
	noop;
equal_passed_2:
	jmp p0_release_wait;

test_mult:
	/* 1.0 * 1.0 = 1.0 */
	LDA 1;
	LDB 0;
	LDX;
	LDY;

	DRPR_HI;
	DRPR_LO;

	/* 1.0 * 2.0 = 2.0 */
	LDA 2;
	LDY;
	DRPR_HI;
	DRPR_LO;

	/* 13.0 * 0.5 = 6.5 */
	LDA 13;
	LDB 0;
	LDX;
	LDA 0;
	LDB 128;
	LDY;
	DRPR_HI;
	DRPR_LO;
	jmp p0_release_wait;

sram_add:
	LDMAR 1;
	LDA DRSRAM;
	LDMAR 3;
	LDB DRSRAM;
	LDMAR 5;
	LDSRAM add;
	LDMAR 0;
	LDA DRSRAM;
	LDMAR 2;
	LDB DRSRAM;
	LDMAR 4;
	if carry cjmp sram_add_with_carry;
	LDSRAM add;
	jmp sram_add_done;
sram_add_with_carry:
	LDSRAM addc;
	jmp sram_add_done;
sram_add_done:
	jmp p0_release_wait;

sram_mult:
	LDMAR 0;
	LDA DRSRAM MARCNT;
	LDB DRSRAM MARCNT;
	LDX;
	LDA DRSRAM MARCNT;
	LDB DRSRAM MARCNT;
	LDY;
	LDSRAM DRPR_HI MARCNT;
	LDSRAM DRPR_LO MARCNT;
	jmp p0_release_wait;

/***********************************************************************
 * load_mar -- load switches into MAR when p0 is pressed.
 *
 * load_mpr -- load switches (low nibble) into MPR when p0 is pressed
 * 
 * sram_write -- write switches into SRAM when p0 is pressed, and
 * increment MAR.
 * 
 * sram_read -- read a value from SRAM.  Address is switches when p0
 * is pressed.  Value is written into MAR (gack!).
 ***********************************************************************/
load_mar:
     	if /p0 cjmp load_mar;
	LDMAR DRSWT;
	jmp p0_release_wait;

load_mpr:
	if /p0 cjmp load_mpr;
	LDMPR DRSWT;
	jmp p0_release_wait;

sram_write:
	if /p0 cjmp sram_write;
	LDSRAM DRSWT;
	do MARCNT;
	jmp p0_release_wait;

sram_read:
	LDMAR DRSRAM;
	jmp p0_release_wait;

/***********************************************************************
 * test_pals -- twiddle every assertion PAL output bit and test the
 * inter-pal dependencies
 ***********************************************************************/
test_pals:
	/* drive signals */
	DRROM;
	DRALU;
	DRREG;
	DRPR_LO;
	DRPR_HI;
	DRSRAM;
	DRSWT;
	DRIN;

	/* load signals */
	do LDA;
	do LDB;
	do LDX;
	do LDY;
	do LDREG;
	do LDSRAM;
	do LDMAR;
	do LDMPR;
	do LDOUT;
	LDCSEG 0;

	/* control signals */
	do MARCNT;
	do Cin;
	do DRCONST;

	/* test   ACK_O	DAV_O	*/
	do CLR_T; /* 0	0	*/
	do ACK_T; /* 1	0	*/
	do DAV_T; /* 1	1	*/
	do ACK_T; /* 0	1	*/
	do DAV_T; /* 0	0	*/
	do ACK_T; /* 1	0	*/
	do DAV_T; /* 1	1	*/
	do CLR_T; /* 0	0	*/

	/* Test DR dep on CTRL -- no DR sigs during DRCONST */
	DRROM DRCONST;
	DRREG DRCONST;
	DRPR_LO DRCONST;
	DRSWT DRCONST;

	/* Test LD dep on CC -- no LD sigs during jumps */
	jmp test_ld_1 LDA;
test_ld_1:
	jmp test_ld_2 LDX;
test_ld_2:
	jmp test_ld_3 LDREG;
test_ld_3:
	jmp test_ld_4 LDMAR;
test_ld_4:

	/* Test CTL dep on DR -- no CTL sigs during jumps or DRROM */
	DRROM MARCNT;
	DRROM Cin;
	DRROM DRCONST; /* *neither* should be asserted! */

	/* test   	ACK_O	DAV_O	*/
	do CLR_T; /* 	0	0	*/
	do ACK_T; /* 	1	0	*/
	DRROM DAV_T; /* 1	0	*/ 
	DRROM ACK_T; /* 1	0	*/
	DRROM CLR_T; /* 1	0	*/

	jmp test_ctl_1;
test_ctl_1:
	jmp test_ctl_2;
test_ctl_2:

	/* test   		ACK_O	DAV_O	*/
	do CLR_T; /* 		0	0	*/
	do ACK_T; /* 		1	0	*/
	jmp test_ctl_3; /* 	1	0	*/
test_ctl_3:

	jmp p0_release_wait;

goto_page_2:
	jmp page_2_entry;

# SET_ADDRESS = f5;
test_counter_1:
	LDCSEG 2;
	/* warp to 2:f6 */

# SET_ADDRESS = f6;
page_2_entry:
	LDCSEG 2;
	/* warp to 2:f7 */

# SET_ADDRESS = f9;
page_2_return_0:
	jmp main_loop;

/***********************************************************************
 * test_cseg -- load the code segment register with 1.  The PC will then
 * wrap to 00 and execute the code in test1.as.
 ***********************************************************************/
# SET_ADDRESS = ff;
# LOAD_ADDRESS = ff;
test_cseg:
	LDCSEG 1;
