#include <stdio.h>
#include <X11/Xlib.h>

main(argc, argv)
   int argc;
   char **argv;
{
     Display *dpy;
     Window win;
     XEvent event;
     int op, x1, x2, y1, y2;

     dpy = XOpenDisplay(NULL);
     if (!dpy) Fail("Can't open display.");

     win = XCreateSimpleWindow(dpy,
			       RootWindow(dpy, DefaultScreen(dpy)),
			       0, 0,
			       256, 192,
			       2,
			       BlackPixel(dpy, DefaultScreen(dpy)),
			       WhitePixel(dpy, DefaultScreen(dpy)));
     if (!win) Fail("Can't open window.");

     XSelectInput(dpy, win, ExposureMask);
     XMapWindow(dpy, win);
     while (1) {
	  XNextEvent(dpy, &event);
	  if (event.type == Expose) break;
     }

     while (1) {
	  read_block(&op, &x1, &y1, &x2, &y2);
	  if (op == 0)
	       XClearArea(dpy, win, 0, 0, 256, 192, False);
	  else {
	       XDrawLine(dpy, win, DefaultGC(dpy, DefaultScreen(dpy)),
			 x1, y1, x2, y2);
	  }

	  XFlush(dpy);
	  XSync(dpy, True);
     }
     /*NOTREACHED*/
}

Fail(s)
   char *s;
{
     fprintf(stderr, "%s\n", s);
     exit(1);
}

int read_block(op, x1, y1, x2, y2)
   int *op, *x1, *y1, *x2, *y2;
{
     char buf[BUFSIZ];
     int dx, s_dx, dy, s_dy;

     fgets(buf, BUFSIZ, stdin);
     *op = atoi(buf);
     /*printf("*op = %d\n", *op);*/
     if (*op == 0) return 0;
     fgets(buf, BUFSIZ, stdin);
     fgets(buf, BUFSIZ, stdin);
     *x1 = atoi(buf);
     /*printf("*x1 = %d\n", *x1);*/
     fgets(buf, BUFSIZ, stdin);
     dx = atoi(buf);
     /*printf("dx = %d\n", dx);*/
     fgets(buf, BUFSIZ, stdin);
     s_dx = atoi(buf);
     /*printf("s_dx = %d\n", s_dx);*/
     fgets(buf, BUFSIZ, stdin);
     *y1 = atoi(buf);
     /*printf("*y1 = %d\n", *y1);*/
     fgets(buf, BUFSIZ, stdin);
     dy = atoi(buf);
     /*printf("dy = %d\n", dy);*/
     fgets(buf, BUFSIZ, stdin);
     s_dy = atoi(buf);
     /*printf("s_dy = %d\n", s_dy);*/
     fgets(buf, BUFSIZ, stdin);
     fgets(buf, BUFSIZ, stdin);
     
     *x2 = *x1 + (s_dx ? 1 : -1) * dx;
     *y2 = *y1 + (s_dy ? 1 : -1) * dy;
     /*
     printf("op = %d, x1 = %d, dx = %d, sdx = %d, y = %d, dy = %d, sdy = %d",
	    *op, *x1, dx, s_dx, *y1, dy, s_dx);
     printf(", x2 = %d, y2 = %d\n", *x2, *y2);
     */
}
