#include "/mit/6.035/lib/header"

#define pushl(x) \
	addl2	$-4, sp ;\
	movl	x, 0(sp)
#define popl(x) \
	movl	(sp), x; \
	addl2	$4, sp

sum:

#define high 		20(fp)
#define low 		16(fp)
#define list_bound  	12(fp)
#define list_data	8(fp)
#define static_link	4(fp)
#define mid 		-4(fp)
#define t1 		-8(fp)
#define t2 		-12(fp)

	# Initialize the frame pointer
	movl	sp, fp

	# Allocate space for mid and 2 temps
	addl2	$-12, sp

	## Code begins here

	# src : if low = high
	cmpl	low, high
	jneq 	else1

	# src : then return(list[low])
	# check low against array bound
	tstl	low
	jlss	failure
	cmpl	low, list_bound
	jgtr	failure

	# move list[low] to r0 and return
	movl	list_data, r2
	mull3	low, $4, r1
	addl2	r1, r2
	movl	(r2), r0
	movl	fp, sp
	rsb

else1:
	# src: mid := (low + high) / 2
	addl3	low, high, t1
	divl2	$2, t1
	movl	t1, mid

	# src: sum(list, low, mid)
	pushr	$(FP)
	pushl(mid)
	pushl(low)
	pushl(list_bound)
	pushl(list_data)
	pushl(static_link)
	jsb 	sum
	addl2	$20, sp
	popr	$(FP)
	# Store temp result into t1
	movl 	r0, t1

	# src: sum(list, mid + 1, high)
	pushr	$(FP)
	pushl(high)
	addl3	mid, $1, t2
	pushl(t2)
	pushl(list_bound)
	pushl(list_data)
	pushl(static_link)
	jsb sum
	addl2	$20, sp
	popr	$(FP)

	# Add result into t1
	addl2	r0, t1

	# Move sum into r0 and return
	movl	t1, r0
	movl	fp, sp
	rsb

failure:
	puts("Array bounds failure.\n")
	stop

start:
	# Initialize frame pointer
	movl	sp, fp

	# Allocate space for list and the dope vector
	addl2	$-24, sp

	# Initializate dope vector
	movl	$4, 0(fp)
	addl3	fp, $8, r0
	movl	r0, 4(fp)

	# Offsets:
	# bound[list] = 0(fp), data[list] = 4(fp)
	# list[0] = 8(fp)

	## Code begins here

	# Initialize list
	movl 	$4, 8(fp)
	movl 	$2, 12(fp)
	movl 	$5, 16(fp)
	movl 	$3, 20(fp)
	movl 	$1, 24(fp)
	
	# Call sum
	pushl($4)
	pushl($0)
	pushl(0(fp))	# list_bound
	pushl(4(fp))	# list_data
	pushl(fp)	# static_link

	jsb	sum

	# Clean up stack after call
	addl2	$16, sp

	# Ouput results
	nout
	puts("\n")

	# Die.
	stop
