#define abs(x) (((x) > 0) ? (x) : -(x))
#define sign(x) ((x) > 0 ? 1 : -1)
#ifdef PROFILE
#define floateq(a,b) (abs((a) - (b)) < 0.001)

extern int PointsOn, PointsOff, PointsPlotted, profile;
#endif

BresenhamLine(x0, y0, x1, y1, s)
   int x0, y0, x1, y1, s;
{
     int dx, dy, d;
     int Tdi, Bdi, xi, yi;
#ifdef PROFILE
     double slope;
#endif
     
     dx = x1 - x0;
     dy = y1 - y0;

#ifdef PROFILE
     slope = (double) dy / (double) dx;
#endif
     
     if (dx == 0) {
	  VerticalLine(x0, y0, y1, s);
	  return;
     }
     else if (dy == 0) {
	  HorizontalLine(x0, x1, y0, s);
	  return;
     }

     if (abs(dx) > abs(dy)) {
	  Tdi = (abs(dy) << 1) - (abs(dx) << 1);
	  Bdi = (abs(dy) << 1);
	  xi = sign(dx);
	  yi = sign(dy);
	  d = Bdi - abs(dx);

	  for (; x0 != x1; x0 += xi) {
#ifdef PROFILE
	       if (profile) {
		    PointsPlotted += 1;
		    if (floateq((double) (y1 - y0) / (double) (x1 - x0) ,
				slope)) 
			 PointsOn += 1;
		    else
			 PointsOff += 1;
	       }
#endif /* PROFILE */
	       PlotToScale(x0, y0, s);
	       if (d > 0) {
		    d += Tdi;
		    y0 += yi;
	       }
	       else
		    d += Bdi;
	  }
     }
     else {
	  Tdi = (abs(dx) << 1) - (abs(dy) << 1);
	  Bdi = (abs(dx) << 1);
	  xi = sign(dx);
	  yi = sign(dy);
	  d =  Bdi - abs(dy);
	  
	  for (; y0 != y1; y0 += yi) {
#ifdef PROFILE
	       if (profile) {
		    PointsPlotted += 1;
		    if (floateq((double) (y1 - y0) / (double) (x1 - x0),
				slope)) 
			 PointsOn += 1;
		    else
			 PointsOff += 1;
	       }
#endif /* PROFILE */
	       PlotToScale(x0, y0, s);
	       if (d >= 0) {
		    d += Tdi;
		    x0 += xi;
	       }
	       else 
		    d += Bdi;
	  }
     }
}
