#include <stdio.h>
#include <math.h>
#include <tgif/tgif.h>

/* An approximate number of pixels for two centimeters */
#define TWOCM 40

int Xpixpercm = 0;
int Ypixpercm = 0;

/*
 * Calibrate() -- draws a box approximately 2cm square and, by asking
 * the user how large it actually is, determines the resolution and
 * aspect ratio of the screen.  Initializes the state required for
 * <foobar>ToPixels.
 */
Calibrate(p)
   Panel p;
{
     char xbuf[BUFSIZ], ybuf[BUFSIZ];
     double x, y;
     
     UsePanel(p);
     Clear(p);
     
     Line(0, TWOCM, TWOCM, TWOCM);
     Line(TWOCM, TWOCM, TWOCM, 0);
     ForceOutput();

     printf("Enter the x and y dimensions of the box in centimeters.\n");
     scanf("%s %s", xbuf, ybuf);
     x = atof(xbuf); y = atof(ybuf);

     Xpixpercm = (int) rint(((double) TWOCM) * 2.0 / x);
     Ypixpercm = (int) rint(((double) TWOCM) * 2.0 / y);

     Clear(p);
}

/*
 * Converts (*xp, *yp), presumably inches, into an equivalent number
 * of pixels based on the result of Calibrate().
 */
InchesToPixels(xp, yp)
   int *xp, *yp;
{
     *xp = rint(*xp * 2.54 * Xpixpercm);
     *yp = rint(*yp * 2.54 * Ypixpercm);
}

     
