#include <math.h>

#define swap(a,b) { int t; t = (a); (a) = (b); (b) = t; }
#ifdef PROFILE
#define floateq(a,b) (abs((a) - (b)) < 0.001)

extern int PointsOn, PointsOff, PointsPlotted, profile;
#endif
     
SimpleLine(x1, y1, x2, y2, s)
   int x1, y1, x2, y2, s;
{
     int dx, dy;
     double xi, yi, edx, edy;

     dx = x2 - x1;
     dy = y2 - y1;

     if (dx == 0)
	  VerticalLine(x1, y1, y2, s);
     else if (dy == 0)
	  HorizontalLine(x1, x2, y1, s);
     else if (abs(dy) < abs(dx)) {
	  if (x2 < x1) {
	       swap(x1, x2);
	       swap(y1, y2);
	  }

	  edy = (double) dy / (double) dx;
	  
	  for (xi = x1, yi = (double) y1; xi <= x2; xi += 1, yi += edy) {
#ifdef PROFILE
	       if (profile) {
		    PointsPlotted += 1;
		    if (floateq(yi, rint(yi)))
			 PointsOn += 1;
		    else
			 PointsOff += 1;
	       }
#endif /* PROFILE */
	       PlotToScale((int) xi, (int) rint(yi), s);
	  }
     }
     else {
	  if (y2 < y1) {
	       swap(x1, x2);
	       swap(y1, y2);
	  }

	  edx = (double) dx / (double) dy;
	  
	  for (yi = y1, xi = (double) x1; yi <= y2; yi += 1, xi += edx) {
#ifdef PROFILE
	       if (profile) {
		    PointsPlotted += 1;
		    if (floateq(xi, rint(xi)))
			 PointsOn += 1;
		    else
			 PointsOff += 1;
	       }
#endif /* PROFILE */
	       PlotToScale((int) rint(xi), (int) yi, s);
	  }
     }
}
