#include <math.h>

#define LOG2 0.693301
#define max(a,b) ((a) > (b) ? (a) : (b))
#define abs(x) ((x) > 0 ? (x) : -(x))
#define swap(a,b) { int t; t = (a); (a) = (b); (b) = t; }

#ifdef PROFILE
#define floateq(a,b) (abs((a) - (b)) < 0.001)

extern int PointsOn, PointsOff, PointsPlotted, profile;
#endif

SymmetricLine(x1, y1, x2, y2, s)
   int x1, y1, x2, y2, s;
{
     int dx, dy;
     double e;
     double xi, yi, edx, edy;

     /* Always draw from left to right, just for conceptual simplicity */
     if (x2 < x1) {
	  swap(x1, x2);
	  swap(y1, y2);
     }

     dx = x2 - x1;
     dy = y2 - y1;
     if (dx == 0)
	  VerticalLine(x1, y1, y2, s);
     else if (dy == 0)
	  HorizontalLine(x1, x2, y1, s);
     else {
	  e = pow(2.0, -ceil(log((double) max(dx, abs(dy))) / LOG2));
	  edx = e*((double) dx);
	  edy = e*((double) dy);
	  
	  for (xi = (double) x1, yi = (double) y1; xi <= (double) x2;
	       xi += edx, yi += edy) {
#ifdef PROFILE
	       if (profile) {
		    PointsPlotted += 1;
		    if (floateq(xi, rint(xi)) && floateq(yi, rint(yi)))
			 PointsOn += 1;
		    else
			 PointsOff += 1;
	       }
#endif /* PROFILE */
	       PlotToScale((int) rint(xi), (int) rint(yi), s);
	  }
     }
}
