;;;; Copyright (c) 1989 Patrick H. Winston -*- mode:lisp -*-

;;;; The material in this file is drawn from copyrighted programs
;;;; in LISP, Third Edition, by Patrick H. Winston and Berthold
;;;; K. P. Horn, and in the San Marco LISP Explorer (R).

;;;; Code for 6.034 Lab 1, Fall 1990

;;;; MATCH

(defun match (p d &optional bindings)
  (cond ((elements-p p d)
         (match-atoms p d bindings))
        ((variable-p p)
         (match-variable p d bindings))
        ((recursive-p p d)
         (match-pieces p d bindings))
        (t 'fail)))

;;;; Special-Case Predicates

(defun elements-p (p d) 
  (and (atom p) (atom d)))

(defun variable-p (p)
  (and (listp p) (eq '? (first p))))

(defun recursive-p (p d)
  (and (listp p) (listp d)))

;;;; Special-Case Matchers

(defun match-atoms (p d bindings)
  ;;See if P and D are the same:
  (if (eql p d)
      ;;If so, return the value of BINDINGS:
      bindings
      ;;Otherwise, return FAIL.
      'fail))

(defun match-variable (p d bindings)
  ;; This function is EXACTLY the same as add-binding.. 
  (let ((var (extract-value p)))
    (if (eq var '_)
	bindings
	(cons (make-binding var d) bindings)))
  )

(defun match-pieces (p d bindings)
  (let ((result (match (first p) (first d) bindings)))
    ;;See if the first parts match producing new bindings:
    (if (eq 'fail result)
        ;;If they do not match, fail.
        'fail
        ;;If they do match, try the rest parts using the resulting bindings:
        (match (rest p) (rest d) result))))

;;;; Pattern Reader

(defun extract-variable (pattern-variable-expression)
  (second pattern-variable-expression))

;;;; Binding Manipulators

(defun make-binding (variable datum)
  (list variable datum))

(defun add-binding (pattern-variable-expression datum bindings)
 (if (eq '_ (extract-variable pattern-variable-expression))
     bindings
     (cons (make-binding
             (extract-variable pattern-variable-expression)
             datum)
           bindings)))

(defun find-binding (pattern-variable-expression binding)
  (unless (eq '_ (extract-variable pattern-variable-expression))
    (assoc (extract-variable pattern-variable-expression) binding)))

(defun extract-value (binding)
  (second binding))
