#include <stdio.h>
#include "transform.h"
#include "Matrix.h"

extern "C" {
#include <tgif/tgif.h>
}

int Shape1Data[] = {
     10, 10, 1,
     10, 100, 1,
     100, 100, 1,
     10, 10, 1,
};
int Shape1Points = 4;

void ScribbleMatrix(Matrix& m)
{
     int i;
     
     for (i=1; i < m.Rows(); i += 1)
	  Line(int(m(i, 1)), int(m(i, 2)),
	       int(m(i+1, 1)), int(m(i+1, 2)));
}

void problem1()
{
     Matrix closed(Shape1Points, 3, Shape1Data);
     Matrix open(5, 3,
		 20, 0, 1,
		 40, 10, 1,
		 10, 50, 1,
		 -50, 100, 1,
		 -20, 45, 1);
     Matrix square(6, 3,
		   0, 20, 1,
		   10, 35, 1,
		   20, 20, 1,
		   20, 0, 1,
		   0, 0, 1,
		   0, 20, 1);
          
     ScribbleMatrix(closed);
     ScribbleMatrix(open*Translator(300,300));
     ScribbleMatrix(square*Translator(240,240));

     ForceOutput();
     WaitForButton();
}

void problem2()
{
     int a, b, c;
     double n,m;
     char z;
     Matrix m1(Shape1Points, 3, Shape1Data);
     Matrix CTM(3, 3,
		1, 0, 0,
		0, 1, 0,
		0, 0, 1);

     while (1) {
	  printf("Current transformation matrix:\n");
	  CTM.Print();
	  printf("Drawing object:\n");
	  (m1 * CTM).Print();
	  
	  Clear();
	  ScribbleMatrix(m1 * CTM);
	  ForceOutput();

	  if (scanf("%1s", &z) == EOF)
	       break;

	  switch (z) {
	  case 't':
	  case 'T':
	       scanf("%d %d", &a, &b);
	       CTM = CTM * Translator(a, b);
	       break;
	  case 's':
	  case 'S':
	       scanf("%f %f", &n, &m);
	       CTM = CTM * Scaler(n, m);
	       break;
	  case 'r':
	  case 'R':
	       scanf("%d %d %d", &a, &b, &c);
	       CTM = CTM * Rotator(a, b, c);
	       break;
	  case 'i':
	  case 'I':
	       CTM.Identify();
	       break;
	  }
     }

     /* Reset the EOF condition */
     clearerr(stdin);
     printf("\n");
}

void problem3()
{
     void Pose(int, int, int, int, int);
     int x, y, f, a, h;

     while (! feof(stdin)) {
	  scanf("%d %d %d %d %d", &x, &y, &f, &a, &h);
	  Clear();
	  Pose(x, y, f, a, h);
	  ForceOutput();
     }

     /* Reset the EOF condition */
     clearerr(stdin);
}
     
main()
{
     Panel p;

     p = NewPanel(500, 500);
     SetFunction(DRAW);
     UsePanel(p);

     problem1();
     problem2();
     problem3();

     DoneWithPanel(p);
     return 0;
}
