#include <math.h>
#include "Matrix.h"
#include "transform.h"

Matrix Translator(int dx, int dy)
{
     Matrix m(3, 3,
	      1,   0, 0,
	      0,   1, 0,
	      dx, dy, 1);

     return m;
}

Matrix Scaler(int sx, int sy)
{
     Matrix m(3, 3,
	      sx,  0, 0,
	      0,  sy, 0,
	      0,   0, 1);

     return m;
}

Matrix Scaler(double sx, double sy)
{
     Matrix m(3, 3,
	      sx,  0.0, 0.0,
	      0.0,  sy, 0.0,
	      0.0,   0.0, 1.0);

     return m;
}

Matrix Rotator(int theta, int xi, int yi)
{
     const double x = double(xi);
     const double y = double(yi);
     const double t = theta * PI / 180.0;
     const double ct = cos(t);
     const double st = sin(t);
     const double xt = x*(1.0 - ct) + y*st;
     const double yt = y*(1.0 - ct) - x*st;
     Matrix m(3, 3,
	      ct,  st, 0.0,
	      -st, ct, 0.0,
	      xt,  yt, 1.0);

     return m;
}

