#ifndef __SPLINE_H__
#define __SPLINE_H__

#include "Matrix.h"

class Spline {
public:
     Spline(Matrix, int = 4);
     Spline(const Spline&);
     ~Spline();

     void DrawOpen();
     void DrawClosed();

private:
     void Draw(const int, const int, const int, const int, const int);
     void Q(int, double, double&, double&);
     double B(int, int, double);
     void MakeOpenKnot();
     void MakeClosedKnot();
	  
     Matrix pts;
     int order, *knot_vec;
};

/* DO NOT ADD ANYTHING AFTER THIS #endif */
#endif /* __SPLINE_H__ */
