(define-tree interface
  (brnchs
   (count > objects if-end-rtn
	  (db-call `(db-count ,objects)))
   (how many > objects are there if-end-rtn
	(db-call `(db-count ,objects)))
   (identify the > attributes of > objects if-end-rtn
	     (db-call `(db-show (db-project ,objects over
					    ,@attributes))))
   (identify > objects if-end-rtn
	     (db-call `(db-show ,objects)))
   (what > attributes are > objects if-end-rtn
	 (db-call `(db-show (db-project ,objects over ,@attributes))))
   ))

(define-tree attributes
  (brnchs (> attribute > attributes rtn (cons attribute
                                              attributes))
          (and > attribute          rtn (list attribute))
          (> attribute              rtn (list attribute))))

(define-tree attribute
  (brnchs (class        rtn 'class)
          (classes      rtn 'class)	;added.
          (color        rtn 'color)
          (colors       rtn 'color)	;added.
          (size         rtn 'size)
          (sizes        rtn 'size)	;added.
          (weight       rtn 'weight)
          (weights      rtn 'weight)	;added.
          (position     rtn 'peg)
          (positions    rtn 'peg)	;added.
          (location     rtn 'peg)
          (locations    rtn 'peg)))	;added.

(define-tree attribute-values
  (brnchs (> attribute-value > attribute-values
             rtn (append attribute-value attribute-values))
          (and > attribute-value rtn attribute-value)
          (> attribute-value rtn attribute-value)))

(define-tree attribute-value
  (brnchs (large        rtn '(size eql large))
          (medium       rtn '(size eql medium))
          (small        rtn '(size eql small))
          (long         rtn '(size eql long))
          (short        rtn '(size eql short))
          (black        rtn '(color eql black))
          (blue         rtn '(color eql blue))
          (red          rtn '(color eql red))
          (yellow       rtn '(color eql yellow))
          (gray         rtn '(color eql gray))
          (heavy        rtn '(weight eql heavy))
          (light        rtn '(weight eql light))))

(define-tree objects
  (brnchs (> determiner > objects rtn objects)
          (> attributed-object and > objects
	       rtn `(db-union ,attributed-object ,objects))
	  (> attributed-object
	     rtn attributed-object)
	  ))

(define-tree attributed-object
    (brnchs (> attribute-values > object
	       rtn `(db-select ,object with ,@attribute-values))
	    (> object
	       rtn object)
	    ))

(define-tree determiner
  (brnchs (a) (the)))

(define-tree object
  (brnchs (saw          rtn '(db-select tools with class eql saw))
          (saws         rtn '(db-select tools with class eql saw))
          (hammer       rtn '(db-select tools with class eql hammer))
          (hammers      rtn '(db-select tools with class eql hammer))
          (wrench       rtn '(db-select tools with class eql wrench))
          (wrenches     rtn '(db-select tools with class eql wrench))
          (screwdriver  rtn '(db-select tools with class eql screwdriver))
          (screwdrivers rtn '(db-select tools with class eql
			      screwdriver))
	  ))
