board_t = cluster is foobar
    
    % Rep invariant:
    % 1) the rep array is 8x8
    
    rep = record[bd: array[array[color_t]], num_black, num_white: int]
    
    create = proc () retuns (board_t)
	% Returns an initialized board. (initial positions, num_black = num_white = 12)
	end create
    
    get_num_black = proc (board: board_t) returns (int)
	% Returns the number of black pieces on the board.
	end get_num_black
    
    get_num_white = proc (board: board_t) returns (int)
	% Returns the number of white pieces on the board.
	end get_num_white
    
    move = proc (board: board_t, turn: turn_t)
	% for each move in turn:
	% 1) Moves a piece move.from to move.to
	% 2) Sets the move.jumped flag to true or false, as appropriate
	% 3) Updates num_{black,white} as appropriate
	end move
    
    get_coord_state = proc (board: board_t, coord: coord_t) retuns (color_t)
	% Returns the current color_t of coord.
	end get_coord_state
    
    undo = proc (board: board_t, turn: turn_t)
	% REQUIRES that turn is actually the last turn taken
	% Foreach move in turn:
	% 1) Undoes move (restores position and replaces jumped pieces)
	% 2) Update num_black and num_white
	% Note that the order of elements yielded in turn is VERY IMPORTANT!
	end undo
    
    unparse = proc (board: board_t) returns (string)
	% Unparses.
	end unparse
    
    parse = proc (s: string) returns (board_t)
	% Parses.
	end parse

    end board_t
