color_t = cluster is 
    create, is_black, is_white, is_empty, equal, parse, unparse
    
    %% 
    %% Overview:
    %% A color_t is one of black, white, empty.  It has no semantic
    %% value, and is used only as an identifier.
    %%
    %% Abstraction function:
    %% A(r) = up(r)   (the abstraction function is a type cast)
    %%
    %% Rep invariant:
    %% true
    %%

    rep = oneof[black, white, empty: null]
    
    create = proc (color: string) returns (color_t) signals (bad_color)
	% Effects: returns a color_t with the appropriate tag if
	% color is "black", "white", or "empty", or signals bad_color.
	end create
    
    is_black = proc (color: color_t) returns (bool)
	% Effects: Returns true of tag color is black, false otherwise
	end is_black

    is_white = proc (color: color_t) returns (bool)
	% Effects: Returns true of tag color is white, false otherwise
	end is_white

    is_empty = proc (color: color_t) returns (bool)
	% Effects: Returns true of tag color is empty, false otherwise
	end is_empty
    
    equal = proc (c1, c2: color_t) returns (bool)
	% Effects: Returns true if c1 and c2 are the same color, false 
	% othersise
	end equal
    
    parse = proc (s: string) returns (color_t) signals (parse_error)
	% Parses.
	end parse
    
    unparse = proc (color: color_t) returns (string)
	% Unparses.
	end unparses
    
    end color_t
