#ifndef __SOLID_H__
#define __SOLID_H__

#include "DynObject.h"
#include "Matrix.h"

class Solid {
public:
     Solid(const Matrix&, int = 10);
     Solid(const Solid&);
     ~Solid();

     /* Members */
     void AddFace(double, int, const int *);
     Solid& operator=(const Solid&);
     int FaceLength(int) const;
     void Print() const;
     inline const int *Face(int) const;
     inline double Color(int) const;
     inline int Faces() const;
     inline int NumFaces() const;
     inline Matrix& Vertices() const;

     /* Overloaded operators */
     friend Solid operator*(const Solid&, const Matrix&);
     friend Solid operator+(const Solid&, const Solid&);

private:
     Matrix vertices;
     DynObject faces, colors;
     int num_faces;
};

inline const int *Solid::Face(int i) const
{
     return *((int **) faces[i]);
}

inline double Solid::Color(int i) const
{
     return *((double *) colors[i]);
}

inline int Solid::Faces() const
{
     return num_faces;
}

inline int Solid::NumFaces() const
{
     return num_faces;
}

inline Matrix& Solid::Vertices() const
{
     return vertices;
}

/* DO NOT ADD ANYTHING AFTER THIS #endif */
#endif /* __SOLID_H__ */
