(define (inspect-stream stream num)
  (newline)
  (if (> num 0)
      (begin
	(display (head stream))
	(display " ")
	(inspect-stream (tail stream) (- num 1)))))

;;;; Problem 6.8

;;; Part a

(define (convolve x-stream h-list)
  (if (null? h-list)
      zeros
      (add-streams (scale-stream (car h-list) x-stream)
		   (convolve (delay-stream x-stream) (cdr h-list)))))

;; part i

(define x-i (cons-stream 0.5 x-i))
(define h-i '(1 -.5 2 -1.5))
(define x*h-i (convolve x-i h-i))
(inspect-stream x*h-i 10)
.5 .25 1.25 .5 .5 .5 .5 .5 .5 .5

;; part ii

(define x-ii ((DT-system '((1) (1 -.5))) (impulse-stream 1)))
(define h-ii '(0 0 1.5 1.5 1.5 1.5 1.5))
(define x*h-ii (convolve x-ii h-ii))
(inspect-stream x*h-ii 10)
0 0 1.5 2.25 2.625 2.8125 2.90625 1.45312 .726562

;; part iii

(define x-iii (make-stream '(0 1 2 3 4 5) 0))
(define h-iii '(0 0 2 2 2))
(define x*h-iii (convolve x-iii h-iii))
(inspect-stream x*h-iii 15)
0 0 0 2 6 12 18 24 18 10 0 0 0 0 0 

;;;; Problem 6.9

;;; Part b

(define x '(1 1 1 -1 -1 1 -1))
(define x-stream (make-stream x))
(define hx (DT-system (list (reverse x) '(1))))

(inspect-stream x-stream 6)
1 1 1 -1 -1 1
(inspect-stream (hx (impulse-stream 1)) 6)
-1 1 -1 -1 1 1
(inspect-stream (hx x-stream) 20)
-1 0 -1 0 -1 0 7 0 -1 0 -1 0 -1 0 0 0 0 0 0 0

;;; Part c

(define a '(0 0 0 0 1 1 1 1 0 1 0 1 0 0 1 1))
(define b '(1 0 0 1 1 0 1 0 1 0 1 1 0 1 0 1))
(define c '(0 1 1 0 0 1 0 0 1 0 0 1 1 1 1 1))

(define message-stream (make-stream (append a b a c b c a c)))

(define (matched-filter lst)
  (DT-system (list (reverse lst) '(1))))

(define ha (matched-filter a))
(define hb (matched-filter b))
(define hc (matched-filter c))

(define output-a (ha message-stream))
(define output-b (hb message-stream))
(define output-c (hc message-stream))

(inspect-stream output-a 128)
0 0 0 0 1 2 2 2 2 2 3 3 3 4 4 8 
5 5 3 4 6 3 4 4 5 5 5 4 5 3 6 4 
4 4 2 5 3 6 4 4 4 3 4 3 3 4 4 8 
4 5 5 4 3 4 4 3 4 5 3 4 5 4 4 4 
5 4 3 5 6 5 6 6 6 5 5 4 5 3 6 4 
4 5 4 6 2 6 4 3 4 4 3 4 5 4 4 4 
4 3 3 4 4 6 6 6 5 4 4 3 3 4 4 8 
4 5 5 4 3 4 4 3 4 5 3 4 5 4 4 4 

(inspect-stream output-b 128)
0 0 0 0 1 1 2 2 2 4 2 5 2 4 4 4 
7 3 6 5 6 5 5 4 6 3 7 5 4 6 3 9 
2 5 4 4 5 3 6 4 4 6 4 6 3 4 5 4 
6 4 6 5 5 5 5 4 4 3 6 3 4 6 5 4 
6 6 4 5 7 4 5 6 7 4 7 6 5 6 3 9 
2 6 5 5 5 4 6 4 4 4 5 3 5 5 5 4 
5 6 3 4 6 3 5 6 5 6 5 7 3 5 5 4 
6 4 6 5 5 5 5 4 4 3 6 3 4 6 5 4 

(inspect-stream output-c 128)
0 0 0 0 1 2 3 4 4 4 3 4 3 3 4 4 
5 5 6 6 5 5 5 5 5 4 5 5 5 7 5 4 
4 5 4 2 4 4 5 6 6 6 4 5 4 4 4 4 
4 5 7 6 4 6 4 2 5 5 1 4 7 4 5 9 
6 4 6 5 4 5 6 5 5 5 7 6 5 7 5 4 
4 6 6 4 5 5 4 3 5 5 2 4 6 4 5 9 
5 3 5 3 2 5 6 5 6 7 5 6 5 4 4 4 
4 5 7 6 4 6 4 2 5 5 1 4 7 4 5 9 

;;;; Problem 6.10

(define signals '(0 4.5+3.5i 8.2+8.6i 10.3+13.7i 10+14i 9.5+13.6i 7.7+9.3i
		    7+5i 6.3+1.6i 5 3+.5i 1.7+2i 3+.5i 5 7+.4i 10+2i 12.6+5i
		    11+2i 11+.4i 12 13.6+.8i 16+3.3i 17.5+4.6i 19+5i 17.5+4.6i
		    16+3.3i 15+1.6i 15+.3i 16 17+1.5i 19+5i 17.7+1.5i
		    16.4-2.5i 15-5.5i 14-5.5i 14-4.5i 15.5-2i 18.7+1.3i
		    21.4+4i 22.6+5i 23.2+4.8i 22.8+3.8i 20.8 23.3+3.5i
		    24.8+4.8i 25.5+5i 25.6+4.2i 23.6+.8i 23.8 25+.3i 26.8+2i
		    28.7+4.2i 30.8+5i 28.7+4.2i 26.8+2i 26.7+.5i 27.5
		    28.2+.8i 29.5+2.5i 30.8+5i 29.5+2.5i 29.2+1i 30 31+.2i
		    32.3+.8i 35.1+4.8i 37+7.8i 37+9.5i 36.3+9.6i 35+7i
		    34.2+4.5i 33.8+.8i 34.5 35.5+.2i 37.6+1.6i 40+5i
		    40.6+2.5i 40+.8i 38.5 37+1i 38.5 41+.2i 43.5+2i))

(define signal-stream (add-streams 
		       (scale-stream 8 (make-stream signals 43.5+2i))
		       (ramp-stream 0 -4)))

(define (write-word word-stream)
  (call-without-interrupts
   (lambda ()
     (let ((d-stream (add-streams word-stream (ramp-stream 80 4))))
       (let ((r1 (make%rect 50 40 450 240)))
	 (eraserect r1)
	 (framerect r1)
	 (disposptr r1))
       (moveto (inexact->exact (round (real-part (head d-stream))))
	       (- 180 (inexact->exact (round (imag-part (head d-stream))))))
       (let loop ((str (tail d-stream)) (n 0))
	 (if (> n 99)
	     #t
	     (begin
	       (lineto (inexact->exact (round (real-part (head str))))
		       (- 180
			  (inexact->exact (round (imag-part (head str))))))
	       (loop (tail str) (1+ n)))))))))

;;;; Problem 6.11

;;; Part c

(define (Hz-a a)
  (DT-system (list (list (square (- 1 a)))
		   (list 1 (* -2 a) (square a)))))
(define Hz-3 ((Hz-a .3) (impulse-stream 1)))
(define Hz-6 ((Hz-a .6) (impulse-stream 1)))

;;; Part d

(define smear-word-3 ((Hz-a .3) signal-stream))
(define smear-word-6 ((Hz-a .6) signal-stream))

;;;; Problem 6.12

(define (inv-Hz-a a)
  (DT-system (list (list 1 (* -2 a) (square a))
		   (list (square (- 1 a)))
		   )))
(define unsmear-word-3 ((inv-Hz-a .3) ((Hz-a .3) signal-stream)))
(define unsmear-word-6 ((inv-Hz-a .6) ((Hz-a .6) signal-stream)))

;;;; Problem 6.13

(define noise-word
  (add-streams signal-stream
	       (add-streams (step-stream -10-10i) (noise-stream 100))))

(define unnoise-word-3 ((Hz-a .3) noise-word))
(define unnoise-word-6 ((Hz-a .6) noise-word))

;;;; Problem 6.14

(define noisy-smeared-word
  (add-streams smear-word-6
	       (add-streams (step-stream -2.2-2.2i) (noise-stream 5))))
(define unnoisy-smeared-word-6 ((inv-Hz-a .6) noisy-smeared-word))

;;;; Problem 6A

(define (stream-to-list stream init-cnt)
  (let loop ((lst '()) (s stream) (cnt init-cnt))
    (if (= cnt 0)
	(reverse lst)
	(loop (cons (head s) lst) (tail s) (1- cnt)))))

(define (cittert signal length ha b)
  (add-streams
   signal
   (scale-stream
    b
    (add-streams
     signal
     (scale-stream
      -1
      (convolve ha (stream-to-list signal length))
      )))))

(define noisy-smeared-word-3
  (add-streams smear-word-3
	       (add-streams (step-stream -2.2-2.2i)
			    (noise-stream 5))))

(define clean-word-1 (cittert noisy-smeared-word-3 85
			      ((Hz-a .3) (impulse-stream 1))
			      .5))

(define clean-word-2 (cittert clean-word-1 85
			      ((Hz-a .3) (impulse-stream 1))
			      .5))
