2.  I'm not quite sure what "interpret" means in this context.  I'll 
assume you mean "explain."

a.  Having no constraints, Prelog will succeed with an infinite number
of arbitrarily long lists (beginning with the empty list), each
element of which can be anything and is represented by an
instantiation of a variable (such as ?first1, ?first2, and so forth).
Each pair of lists will (correctly) have its unbound instantiated
variables in reverse order, for example

list1 = (list ?first2 ?first3 ?first4)
list2 = (list ?first4 ?first3 ?first2)

b.  The set of lists that are their own reversed values is (1) the
empty list, (2) all lists with all the same element, and (3) lists
that are "palindromes".  Therefore, Prelog will return an infinite set
of lists of arbitrary lengths which satisfy these criteria, for
example

list = (list),
list = (list ?first3 ?first3)
list = (list ?first4 ?first3 ?first4)

c.  In the first example, the rules specify a relatively
straightforward approach to computing the answer, and Prelog uses that
approach.  In the second example, Prelog effectively has to search the
space of all possible answers until it finds one; therefore, the first
is much more efficient to compute.

d.  Prelog attemps to satisfy all predicates in an and expression in
all possible ways before trying other bindings for other variables.
Thus, for the list (b a b), the predicate (member a ?list) will
succeed and then the predicate (member b ?list) will succeed twice.

e.  This set of predicates will never return a list beginning with b,
since the predicate (member a ?list) will constrain the first element
to be a before the second predicate is executed, and since there is an
infinite set of lists that satisfy that constraint the first predicate
will never fail.

f.  The rule (member a ?list) will not return any values with this
ordering of predicates, because the first rule will succeed and
execute its antecedent, which will succeed on the first rule which
will execute its antedecent, and thus results in an infinite loop.

